<?php
//[tps-auto-close-tickets]

class TPS_Auto_Close {
	
	function __construct() {
		// Init
		add_action( 'init', array( $this, 'tps_auto_close_init' ) );
	}
	
	function tps_auto_close_init() {

		// Currently supported shortcodes
		add_shortcode( 'tps-auto-close-tickets', array( $this, 'tps_auto_close_tickets' ) );


	}


	function tps_auto_close_tickets( $atts, $content = null ){
		

		extract( shortcode_atts( array(
					//'ticketid' => '',
				), $atts ) );

		// Find all tickets with status solved

		$loop = new WP_Query(array(
				'fields' => 'ids',
				'post_type' => 'tickets', 
				'posts_per_page' => -1,
				'meta_query'     => array(
				    array(
				      'key'    => 'tps_status', 
					  'value'  => 'solved',
				    ) 
				  ),
				)
			);

		$Front_Form = new Front_Form();
		$settings = $Front_Form->settings; 
        $time = $Front_Form->tps_get_current_time('ts');     
		$timestr = $Front_Form->tps_get_current_time("YmdHisfromts",$time);


		if(isset($loop)){
		    if ( $loop->have_posts() ){

	        while ( $loop->have_posts() ) : $loop->the_post();

	        	$action = array();
	        	$ticketid = get_the_ID();
			    $status = get_post_meta( $ticketid, 'tps_status', true );
			    $last_activity = get_post_meta( $ticketid, 'tps_last_activity', true );
			    $tps_ticket_solved_time = get_post_meta( $ticketid, 'tps_ticket_solved_time', true );
				
				//echo "<br>".$ticketid."<br>";
				
				if(isset($settings['enable_user_rating']) && $settings['enable_user_rating'] == "on"){

					//echo "enable user rating<br>";
				    $feedb_status = get_post_meta( $ticketid, 'tps_feedback_status', true );
				    
				   // echo $feedb_status;
				    if($feedb_status == "" || $feedb_status == "na"){
					   // echo "<br>status NA<br>";
					    // send email asking for feedback

					    $email_sent = $this->tps_send_user_feedback_email($ticketid,$settings,$tps_ticket_solved_time,$time,$timestr);

					    if(isset($email_sent['status']) && $email_sent['status']){

					    	$history_msg = $email_sent['history_msg'];
					        $update_history = $Front_Form->tps_update_ticket_history($ticketid,$history_msg);	
					    }


				    } else if($feedb_status == "waiting"){
					  //  echo "<br> email sent. waiting for feedback";

					    $time_passed = false;

						// if solved ticket time + feedback waiting time is more than current time, then $time_passed is true
						
						$wait_time = 0;
						$days = 3; // default 3 days
						
						if(isset($settings['feedback_email_auto_close_time']) && $settings['feedback_email_auto_close_time'] != "" && is_numeric($settings['feedback_email_auto_close_time'])){
							$days = $settings['feedback_email_auto_close_time'];
						}

						$wait_time = $days * 24 * 60 * 60;
						//$wait_time = 10;
						
						if($time > ($tps_ticket_solved_time + $wait_time)){
							$time_passed = true;
						}
						//echo $tps_ticket_solved_time - $time;

						if($time_passed){
						//	echo "<br>Feedback Wait time over. Auto Close ticket<br>";
							$action['status'] = "closed";
							$action['time'] = $time;
							$action['timestr'] = $timestr;
							$action['type'] = "feedback_waittime_over";
							$action['feedback_status'] = "nofeedback";

							$this->tps_ticket_auto_close_action($ticketid,$action,$status,$Front_Form);
						}




				    } else if($feedb_status == "good" || $feedb_status == "bad"){
					 //   echo "<br>".$ticketid." feedback received as ".$feedb_status." <br>";

						$action['status'] = "closed";
						$action['time'] = $time;
						$action['type'] = "feedback_received";
						$action['feedback_status'] = $feedb_status;

						$this->tps_ticket_auto_close_action($ticketid,$action,$status,$Front_Form);

				    } else if($feedb_status == "nofeedback"){
					  //  echo "<br>".$ticketid." No feedback received";

						$action['status'] = "closed";
						$action['time'] = $time;
						$action['type'] = "feedback_notreceived";
						$action['feedback_status'] = "nofeedback";

						$this->tps_ticket_auto_close_action($ticketid,$action,$status,$Front_Form);

				    }


				} else {

					// if user rating is disabled

					// if time passed to auto close ticket, then close ticket.
					$time_passed = false;

					// if solved ticket time + auto close time is more than current time, then $time_passed is true
					
					$wait_time = 0;
					$days = 3; // default 3 days
					
					if(isset($settings['auto_close_time']) && $settings['auto_close_time'] != "" && is_numeric($settings['auto_close_time'])){
						$days = $settings['auto_close_time'];
					}

					$wait_time = $days * 24 * 60 * 60;
					//$wait_time = 10;

					if($time > ($tps_ticket_solved_time + $wait_time)){
						$time_passed = true;
					}
					
					
					if($time_passed){

						$action['status'] = "closed";
						$action['time'] = $time;
						$action['type'] = "autoclose";
						$action['feedback_status'] = "disabled";

						$this->tps_ticket_auto_close_action($ticketid,$action,$status,$Front_Form);

					}
			}
			//echo "<hr>";

			endwhile;

		    } else {
				echo __("No tickets found to be closed.","tpsupport");
			}
		}

	}


	function tps_ticket_auto_close_action($ticketid,$action,$status,$Front_Form){

		$time = $action['time'];
		$timestr = $action['timestr'];
		$type = $action['type'];
		$history_status = "";
	
		// update last activity, history, status

		update_post_meta( $ticketid, 'tps_status', "closed", false );
		update_post_meta( $ticketid, 'tps_last_activity', $time, false );

		if($type == "autoclose"){

           $history_status = "Status Changed from ".$status." to closed on: ".$timestr." [|||status:closed|||time:".$time."|||action_type:feedback_disabled|||type:auto|||from_status:".$status."]";

		} else if($type == "feedback_waittime_over"){

            $history_status = "Status Changed from ".$status." to closed on: ".$timestr." [|||status:closed|||time:".$time."|||action_type:feedback_waittime_over|||tps_feedback_status:nofeedback|||type:auto|||from_status:".$status."]";
	
			update_post_meta( $ticketid, 'tps_feedback_status', "nofeedback", false );

		} else if($type == "feedback_received"){

            $history_status = "Status Changed from ".$status." to closed on: ".$timestr." [|||status:closed|||time:".$time."|||action_type:feedback_received|||tps_feedback_status:".$action['feedback_status']."|||type:auto|||from_status:".$status."]";

		} else if($type == "feedback_notreceived"){

            $history_status = "Status Changed from ".$status." to closed on: ".$timestr." [|||status:closed|||time:".$time."|||action_type:feedback_notreceived|||tps_feedback_status:nofeedback|||type:auto|||from_status:".$status."]";

		}

        $update_history = $Front_Form->tps_update_ticket_history($ticketid,$history_status);

		echo __("Ticket Id:","tpsupport"). $ticketid." " .__("Status: Auto Closed","tpsupport")."<hr>";


	}


	function tps_send_user_feedback_email($ticketid,$settings,$tps_ticket_solved_time,$time,$timestr){
		
			$time_passed_to_feedback_email = false;
		

			$email_after = 0;
			if(isset($settings['feedback_email_after_hours']) && is_numeric($settings['feedback_email_after_hours'])){
				$email_after = $settings['feedback_email_after_hours'];
			}
			//$email_after = 1000;

			if($time > ($tps_ticket_solved_time + $email_after)){
				$time_passed_to_feedback_email = true;				
			}

			$ret = array();
			$ret['status'] = false;
			$ret['history_msg'] = "";
			
			if($time_passed_to_feedback_email){

					//echo "<br>send email ready<br>";

					add_filter( 'wp_mail_content_type', 'tps_email_content_type' );
					
					$dispname = get_post_meta( $ticketid, 'tps_dispname', true );
					
		            $ticket_details_pageid = $settings['tps_page_ticket_view']; //329;
		            $page_link = get_page_link($ticket_details_pageid);
					$ticket_url = esc_url( add_query_arg( 'ticketid', $ticketid, $page_link) );
					$ticket_post_title = get_the_title($ticketid);
					$good_url = esc_url( add_query_arg( array('ticketid' => $ticketid, 'rate' => 'good'), $page_link) );
					$bad_url = esc_url( add_query_arg( array('ticketid' => $ticketid, 'rate' => 'bad'), $page_link) );

				     $placeholders = array(
				            '%BLOGNAME%' => get_option('blogname'),
				            '%TICKETID%' => $ticketid,
				            '%NAME%' => $dispname,
				            '%TITLE%' => "<a href='" . $ticket_url . "'>" . $ticket_post_title . "</a>",
				            '%BLOGURL%' => "<a href='" . site_url() . "'>" . site_url() . "</a>",
				            '%TICKETURL%' => "<a href='" . $ticket_url . "'>" . $ticket_url . "</a>",
				            '%GOODURL%' => $good_url,
				            '%BADURL%' => $bad_url,
				           
				        );


						$subj = $settings['feedback_email_subject'];
			            $subj = html_entity_decode(tps_generic_placeholder_replacer($subj, $placeholders));

						$msg = $settings['feedback_email_message'];
			            $msg = html_entity_decode(tps_generic_placeholder_replacer($msg, $placeholders));

					    $to = get_post_meta( $ticketid, 'tps_email', true );

						if(wp_mail( $to, $subj, $msg )){
							//echo "email sent";
							update_post_meta( $ticketid, 'tps_feedback_status', "waiting", false );

							remove_filter( 'wp_mail_content_type', 'tps_email_content_type' );

							$history_msg = "Feedback Email Sent to email: ".$to." on: ".$timestr." [|||email:".$to."|||name:".$dispname."|||time:".$time."|||type:feedback_email_sent]";

							
							$ret['status'] = true;
							$ret['history_msg'] = $history_msg;
													
						}
			}
			return $ret;

	}

}

$GLOBALS['tps_auto_close'] = new TPS_Auto_Close;

?>