<?php


/*
* Creating a function to create our CPT
*/
 
function tpsupport_cpt_tickets() {
    
 
// Set UI labels for Custom Post Type
    $labels = array(
        'name'                => _x( 'Tickets', 'Post Type General Name', 'tpsupport' ),
        'singular_name'       => _x( 'Ticket', 'Post Type Singular Name', 'tpsupport' ),
        'menu_name'           => __( 'Tickets', 'tpsupport' ),
        'parent_item_colon'   => __( 'Parent Ticket', 'tpsupport' ),
        'all_items'           => __( 'All Tickets', 'tpsupport' ),
        'view_item'           => __( 'View Ticket', 'tpsupport' ),
        'add_new_item'        => __( 'Add New Ticket', 'tpsupport' ),
        'add_new'             => __( 'Add New', 'tpsupport' ),
        'edit_item'           => __( 'Edit Ticket', 'tpsupport' ),
        'update_item'         => __( 'Update Ticket', 'tpsupport' ),
        'search_items'        => __( 'Search Ticket', 'tpsupport' ),
        'not_found'           => __( 'Not Found', 'tpsupport' ),
        'not_found_in_trash'  => __( 'Not found in Trash', 'tpsupport' ),
    );
     
// Set other options for Custom Post Type
     
    $args = array(
        'label'               => __( 'tickets', 'tpsupport' ),
        'description'         => __( 'Support Tickets of all users', 'tpsupport' ),
        'labels'              => $labels,
        // Features this CPT supports in Post Editor
        'supports'            => array( 'title', 'editor', 'revisions','author'),
        // You can associate this CPT with a taxonomy or custom taxonomy. 
        'taxonomies'          => array( 'topic' ),
        /* A hierarchical CPT is like Pages and can have
        * Parent and child items. A non-hierarchical CPT
        * is like Posts.
        */ 
        'hierarchical'        => true,
        'public'              => true,
        'show_ui'             => true,
        'show_in_menu'        => true,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 5,
        'can_export'          => true,
        'has_archive'         => true,
        'exclude_from_search' => false,
        'publicly_queryable'  => false,
        'capability_type'     => 'post',
    );
     
    // Registering your Custom Post Type
    register_post_type( 'tickets', $args );




    // Add new taxonomy, make it hierarchical (like categories)
  $labels = array(
    'name'              => _x( 'Topics', 'taxonomy general name', 'tpsupport' ),
    'singular_name'     => _x( 'Topic', 'taxonomy singular name', 'tpsupport' ),
    'search_items'      => __( 'Search Topics', 'tpsupport' ),
    'all_items'         => __( 'All Topics', 'tpsupport' ),
    'parent_item'       => __( 'Parent Topic', 'tpsupport' ),
    'parent_item_colon' => __( 'Parent Topic:', 'tpsupport' ),
    'edit_item'         => __( 'Edit Topic', 'tpsupport' ),
    'update_item'       => __( 'Update Topic', 'tpsupport' ),
    'add_new_item'      => __( 'Add New Topic', 'tpsupport' ),
    'new_item_name'     => __( 'New Topic Name', 'tpsupport' ),
    'menu_name'         => __( 'Topic', 'tpsupport' ),
  );

  $args = array(
    'hierarchical'      => true,
    'labels'            => $labels,
    'show_ui'           => true,
    'show_admin_column' => true,
    'query_var'         => true,
    'rewrite'           => array( 'slug' => 'topic' ),
    /*'meta_box_cb'       => true,*/
  );

  register_taxonomy( 'topic', array( 'tickets' ), $args );
 






// Set UI labels for Custom Post Type
    $labels = array(
        'name'                => _x( 'FAQ', 'Post Type General Name', 'tpsupport' ),
        'singular_name'       => _x( 'FAQ', 'Post Type Singular Name', 'tpsupport' ),
        'menu_name'           => __( 'FAQ', 'tpsupport' ),
        'parent_item_colon'   => __( 'Parent FAQ', 'tpsupport' ),
        'all_items'           => __( 'All FAQ', 'tpsupport' ),
        'view_item'           => __( 'View FAQ', 'tpsupport' ),
        'add_new_item'        => __( 'Add New FAQ', 'tpsupport' ),
        'add_new'             => __( 'Add New', 'tpsupport' ),
        'edit_item'           => __( 'Edit FAQ', 'tpsupport' ),
        'update_item'         => __( 'Update FAQ', 'tpsupport' ),
        'search_items'        => __( 'Search FAQ', 'tpsupport' ),
        'not_found'           => __( 'Not Found', 'tpsupport' ),
        'not_found_in_trash'  => __( 'Not found in Trash', 'tpsupport' ),
    );
     
// Set other options for Custom Post Type
     
    $args = array(
        'label'               => __( 'tpsfaq', 'tpsupport' ),
        'description'         => __( 'General FAQ', 'tpsupport' ),
        'labels'              => $labels,
        // Features this CPT supports in Post Editor
        'supports'            => array( 'title', 'editor', 'revisions','author','categories'),
        // You can associate this CPT with a taxonomy or custom taxonomy. 
        'taxonomies'          => array( 'tpsfaqcat' ),
        /* A hierarchical CPT is like Pages and can have
        * Parent and child items. A non-hierarchical CPT
        * is like Posts.
        */ 
        'hierarchical'        => true,
        'public'              => true,
        'show_ui'             => true,
        'show_in_menu'        => true,
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 5,
        'can_export'          => true,
        'has_archive'         => true,
        'exclude_from_search' => false,
        'publicly_queryable'  => false,
        'capability_type'     => 'post',
    );
     
    // Registering your Custom Post Type
    register_post_type( 'tpsfaq', $args );


    // Add new taxonomy, make it hierarchical (like categories)
  $labels = array(
    'name'              => _x( 'FAQ Categories', 'taxonomy general name', 'tpsupport' ),
    'singular_name'     => _x( 'FAQ Category', 'taxonomy singular name', 'tpsupport' ),
    'search_items'      => __( 'Search FAQ categoires', 'tpsupport' ),
    'all_items'         => __( 'All FAQ categories', 'tpsupport' ),
    'parent_item'       => __( 'Parent FAQ category', 'tpsupport' ),
    'parent_item_colon' => __( 'Parent FAQ category:', 'tpsupport' ),
    'edit_item'         => __( 'Edit FAQ category', 'tpsupport' ),
    'update_item'       => __( 'Update FAQ category', 'tpsupport' ),
    'add_new_item'      => __( 'Add New FAQ category', 'tpsupport' ),
    'new_item_name'     => __( 'New FAQ category Name', 'tpsupport' ),
    'menu_name'         => __( 'FAQ category', 'tpsupport' ),
  );

  $args = array(
    'hierarchical'      => true,
    'labels'            => $labels,
    'show_ui'           => true,
    'show_admin_column' => true,
    'query_var'         => true,
    'rewrite'           => array( 'slug' => 'tpsfaqcat' ),
    /*'meta_box_cb'       => true,*/
  );

  register_taxonomy( 'tpsfaqcat', array( 'tpsfaq' ), $args );
 
}
 
/* Hook into the 'init' action so that the function
* Containing our post type registration is not 
* unnecessarily executed. 
*/
 
add_action( 'init', 'tpsupport_cpt_tickets', 0 );



function tpsupport_cpt_tickets_agent_groups() {
 
// Set UI labels for Custom Post Type
    $labels = array(
        'name'                => _x( 'Agent groups', 'Post Type General Name', 'tpsupport' ),
        'singular_name'       => _x( 'Agent group', 'Post Type Singular Name', 'tpsupport' ),
        'menu_name'           => __( 'Agent groups', 'tpsupport' ),
        'parent_item_colon'   => __( 'Parent Agent group', 'tpsupport' ),
        'all_items'           => __( 'All Agent groups', 'tpsupport' ),
        'view_item'           => __( 'View Agent group', 'tpsupport' ),
        'add_new_item'        => __( 'Add New Agent group', 'tpsupport' ),
        'add_new'             => __( 'Add New', 'tpsupport' ),
        'edit_item'           => __( 'Edit Agent group', 'tpsupport' ),
        'update_item'         => __( 'Update Agent group', 'tpsupport' ),
        'search_items'        => __( 'Search Agent group', 'tpsupport' ),
        'not_found'           => __( 'Not Found', 'tpsupport' ),
        'not_found_in_trash'  => __( 'Not found in Trash', 'tpsupport' ),
    );
     
// Set other options for Custom Post Type
     
    $args = array(
        'label'               => __( 'agentgroups', 'tpsupport' ),
        'description'         => __( 'Support Agent groups of all agent users in the system', 'tpsupport' ),
        'labels'              => $labels,
        // Features this CPT supports in Post Editor
        'supports'            => array( 'title'),
        // You can associate this CPT with a taxonomy or custom taxonomy. 
     //   'taxonomies'          => array( 'topic' ),
        /* A hierarchical CPT is like Pages and can have
        * Parent and child items. A non-hierarchical CPT
        * is like Posts.
        */ 
        'hierarchical'        => true,
        'public'              => true,
        'show_ui'             => true,
        'show_in_menu'        => 'edit.php?post_type=tickets',
        'show_in_nav_menus'   => true,
        'show_in_admin_bar'   => true,
        'menu_position'       => 5,
        'can_export'          => true,
        'has_archive'         => true,
        'exclude_from_search' => false,
        'publicly_queryable'  => false,
        'capability_type'     => 'post',
    );
     
    // Registering your Custom Post Type
    register_post_type( 'agentgroups', $args );
 
}
 
/* Hook into the 'init' action so that the function
* Containing our post type registration is not 
* unnecessarily executed. 
*/
 
add_action( 'init', 'tpsupport_cpt_tickets_agent_groups', 0 );
?>