<?php

class TPS_Faq_View {

	
	function __construct() {
		// Init
		add_action( 'init', array( $this, 'tps_faq_view_init' ) );
	}
	
	function tps_faq_view_init() {

		// Currently supported shortcodes
		add_shortcode( 'tps-faq-detail-view', array( $this, 'tps_display_faq_view' ) );


	}


	function tps_display_faq_view( $atts, $content = null ){
		

		extract( shortcode_atts( array(
					'faqid' => '',
					'class' => '',
				), $atts ) );
		


		$url = plugins_url('/', __FILE__).'../css/style.min.css';
        wp_deregister_style('tps-style-front');
        wp_register_style('tps-style-front', $url);
        wp_enqueue_style('tps-style-front');

		$Front_Form = new Front_Form();
		$settings = $Front_Form->settings; 


		if(isset($_GET['faqid']) && $_GET['faqid'] != "" && $_GET['faqid'] != "0"){

			$faqid = $_GET['faqid'];
			
				$post = get_post($faqid); //assuming $id has been initialized
				 if($post){
					setup_postdata($post);

					$comments_enable = true;

	                $faq_details_pageid = $settings['tps_page_faq_detail']; //329;

	 				$terms = wp_get_post_terms( $faqid, "tpsfaqcat",array("fields" => "names"));

	                echo "<div class='single-post'>";

	                echo "<div class='fullcol'>";
					echo "<h2 class='faq_cat widget-title'>".$terms[0]."</h2>";
					 echo "<h3 class='ticket-title entry-title'>".
					 "<a href='".esc_url( add_query_arg( 'faqid', $faqid, get_page_link($faq_details_pageid)) )."'>".$post->post_title."</a></h3>";

						$avatar = "";
						 if(get_avatar( $post->author, 40 )){
						 	$avatar = "<span class='pic'>".get_avatar( $post->author, 40 )."</span>";
						 }

						
						$elapsed_time = tps_time_elapsed_string($post->post_date);
						$last_modified_time = tps_time_elapsed_string(get_the_modified_date());

						 echo "<div class='ticket-author'>
						 	".$avatar."
							<span class='det'>
								<span class='name'>".get_the_author()."</span>
								<span class='time' title='".$post->post_date."'>".__("Created On:","tpsupport")." ".$elapsed_time." &nbsp;&nbsp;|&nbsp;&nbsp; ". __("Last Modified:","tpsupport"). " ".$last_modified_time ."</span>
							</span>
						 </div>";

					 echo "<div class='ticket-entry-content entry-content'>"; 


					 echo "<article>".wpautop($post->post_content)."";
					

				 	 echo "</article></div>"; // end .entry-content
				 	 echo "</div>"; // .leftcol

					 echo "<div class='tps-spacer'></div>";
					 
					 $new_ticket_pageid = $settings['tps_page_new_ticket'];
					 $new_ticket_url = esc_url(  get_page_link($new_ticket_pageid) );
					 echo "<h3>".__("Didn't find what you are looking for? ","tpsupport")." ";
					 echo "<a class='button' href='".$new_ticket_url."'>".__("Generate New Ticket","tpsupport")."</a></h3>";
				echo "</div>"; // .single-post end

				} else {
					echo __("No FAQ (".$faqid.") Found.","tpsupport");
				}

				wp_reset_postdata();



		} else {
			echo "No FAQ Found.";
		}

	}


	function tps_comment_author_details($value,$Front_Form){


					 		//print_r($value);
					 		$c_exp = explode("-",$value['userId']);
					 		$val_userId = "";
					 		$val_ts = "";
					 		if(isset($c_exp[0])){
						 		$val_userId = $c_exp[0];
					 		}
					 		if(isset($c_exp[1])){
					 			$val_ts = $c_exp[1];
					 		}

							 $avatar = "";
							 if($val_userId != "" && get_avatar($val_userId, 40)){
							 	$avatar = "<span class='pic'>".get_avatar($val_userId, 40 )."</span>";
							 }

							 $elapsed_time = "";
							 $comment_date = "";
							 $comment_elapsed_time = "";
							 if($val_ts != ""){
								 $comment_date = $Front_Form->tps_get_current_time("localYmdHisfromts",$val_ts);
								 $comment_elapsed_time = tps_time_elapsed_string($comment_date);
							 }

							 $comment_user = get_user_by("id",$val_userId);
							 //print_r($comment_user);

							 echo "<div class='ticket-author'>
							 	".$avatar."
								<span class='det'>
									<span class='name'>".$comment_user->display_name."</span>
									<span class='time' title='".$comment_date."'>".$comment_elapsed_time."</span>
								</span>
							 </div>";

	}

}

$GLOBALS['tps_faq_view'] = new TPS_Faq_View;

?>