<?php
/**
 * Frontend Uploader Settings
 */
class Front_Form_Settings {

	private $settings_api, $public_post_types = array();

	function __construct() {
		$this->settings_api = new WeDevs_Settings_API;
		//$this->settings_api->test_func("hello");
		add_action( 'current_screen', array( $this, 'tps_action_current_screen' ) );
		add_action( 'admin_menu', array( $this, 'tps_action_admin_menu' ) );
		//add_action('admin_init', array($this,'sandbox_initialize_theme_options'));
		add_action( 'admin_init', array($this,'tps_plugin_admin_init') );
	}

	/**
	 * Only run if current screen is plugin settings or options.php
	 * @return [type] [description]
	 */
	function tps_action_current_screen() {

		$screen = get_current_screen();
		//echo "<pre>"; print_r($screen); echo "</pre>"; die;
		if ( in_array( $screen->base, array( 'support-ticket_page_tps_settings_email','admin_page_tps_settings_email','toplevel_page_tps_settings', 'options' ) ) ) {
			$this->settings_api->tps_set_sections( $this->tps_get_settings_sections() );
			$this->settings_api->tps_set_fields( $this->tps_get_settings_fields() );
			// Initialize settings
			$this->settings_api->admin_init();
			$this->tps_enqueue_settings_script();

		}
	}

	/**
	 * Get post types for checkbox option
	 * @return array of slug => label for registered post types
	 */
	static function tps_get_post_types() {
		$tps_public_post_types = tps_get_post_types( array( 'public' => true ), 'objects' );
		foreach( $tps_public_post_types as $slug => $post_object ) {
			if ( $slug == 'attachment' ) {
				unset( $tps_public_post_types[$slug] );
				continue;
			}
			$tps_public_post_types[$slug] = $post_object->labels->name;
		}
		return $tps_public_post_types;
	}

	//protected $views = array();
	function tps_action_admin_menu() {
		
		
		//$this->views[$view_hook_name] = 'options';
		
		/*add_options_page( __( 'Frontend Uploader Settings', 'tpsupport' ) , __( 'Frontend Uploader Settings', 'tpsupport' ), 'manage_options', 'tps_settings', array( $this, 'plugin_page' ) );*/

        add_menu_page('Support Ticket', __('Support Ticket', 'tpsupport'), 'manage_options', 'tps_settings',  array( $this, 'tps_plugin_page' ));

		add_submenu_page( 
				 'tps_settings',
		        'Email Settings',
		        __('Email Settings', 'tpsupport'),
		        'manage_options',
		        'tps_settings_email',
				array( $this, 'tps_plugin_page_email' )
		    );

		add_submenu_page( 
				 'tps_settings',
		        'Statistics',
		        __('Statistics', 'tpsupport'),
		        'manage_options',
		        'tps_settings_stats',
				array( $this, 'tps_plugin_page_stats' )
		    );

		/*
        add_menu_page('Support Ticket Statistics', __('Support Ticket Statistics', 'tpsupport'), 'manage_options', 'tps_settings_stats',  array( $this, 'tps_plugin_page_stats' ));*/


	}

	function tps_plugin_page_stats(){

        $url = plugins_url('/', __FILE__).'../../../../css/style-admin.css';
        wp_deregister_style('tpsadmin');
        wp_register_style('tpsadmin', $url);
        wp_enqueue_style('tpsadmin');

        $url = plugins_url('/', __FILE__).'../../../../js/echarts-all.js';
        wp_deregister_script('tps-echarts-js');
        wp_register_script('tps-echarts-js', $url);
        wp_enqueue_script('tps-echarts-js','jquery');

        /*$url = plugins_url('/', __FILE__).'../../../../js/echarts-stats.js';
        wp_deregister_script('tps-echarts-stats-js');
        wp_register_script('tps-echarts-stats-js', $url);
        wp_enqueue_script('tps-echarts-stats-js');*/

        /*echo '<div class="tps-chart-container">
        	<h3>Bar Graph</h3>
                          <div class="" style="height:300px" id="user_type_bar"></div>
                      </div>';

        echo '<div class="tps-chart-container">
                  <div class="" style="height:300px" id="browser_type_bar"></div>
              </div>';

      	echo '<div class="tps-chart-container">
                  <div class="" style="height:200px" id="user_type"></div>
              </div>';

		echo '<div class="tps-chart-container">
                  <div class="" style="height:200px" id="browser_type"></div>
              </div>';

        echo '<div class="tps-chart-container">
              <div class="chart has-fixed-height" style="height:200px" id="page_views_today"></div>
          </div>';*/



		/*echo "<pre>
		ticket status count - bar graph,
			- new, open, solved, pending , closed

		ticket feedback ratings - bar graph,
			- good, bad, waiting, no feedback

		agent assigned ticket count - bar graph
			- agent 1, agent 2, ...

		agent feedback ratings - multi bar graph
			- agent 1
				- good, bad, waiting, nofeedback
			- agent 2
				- good, bad, waiting, nofeedback
			... 

		each agent groups - agent, ticket count - multi bar
			- group 1
				- agent, open tickets, closed, pending, waiting, solved

		daily tickets generated count - area graph
			- date, tickets

		- client ticket counts
			- client 1 
				- tickets
			- client 2
				- tickets

		- topics ticket count
		</pre>";*/



		// loop through all tickets


	$loop = new WP_Query(array(
		'post_type' => 'tickets', 
		'posts_per_page' => -1,
		)
	);

	$ticket_status_count = array(
		'new' => 0,
		'open' => 0,
		'pending' => 0,
		'solved' => 0,
		'closed' => 0
	);

	$ticket_feedback_status_count = array(
		'na' => 0,
		'waiting' => 0,
		'good' => 0,
		'bad' => 0,
		'nofeedback' => 0
	);
	$ticket_date_count = array();

	$agent_status_count = array();

	$agents_arr = tps_get_all_entities_arr('agents','','','idname');
	$agents_count = $this->tps_declare_array($agents_arr);

	$agentgroups_arr = tps_get_all_entities_arr('groups','','','idname');
    $agentgroups_count = $this->tps_declare_array($agentgroups_arr);

    $agentgroups_admin_arr = tps_get_all_entities_arr('groupsadmin','','','idname');
    $agentgroups_admin_count = $this->tps_declare_array($agentgroups_admin_arr);

    $agentsadmin_arr = tps_get_all_entities_arr('agentadmin','','','idname');
    $agentsadmin_count = $this->tps_declare_array($agentsadmin_arr);

	$clients_arr = tps_get_all_entities_arr('clients','','','idname');
	$clients_count = $this->tps_declare_array($clients_arr);

    /*echo "<pre>";
	print_r($agents_arr);
	print_r($agentgroups_arr);
	print_r($agentgroups_admin_arr);
	print_r($agentsadmin_arr);
	print_r($clients_arr);
    echo "</pre>";*/

    /*echo "<pre>";
	print_r($agents_count);
	print_r($agentgroups_count);
	print_r($agentgroups_admin_count);
	print_r($agentsadmin_count);
	print_r($clients_count);
    echo "</pre>";*/

    $entities = $this->tps_merge_all_array($agents_count,$agentgroups_count,$agentgroups_admin_count,$agentsadmin_count,$clients_count);
    $ticket_count = 0;

	if(isset($loop)){
		if ( $loop->have_posts() ) :
		while ( $loop->have_posts() ) : $loop->the_post();
	
		    $ticket_count++;
	
			$ticketid = get_the_ID();
		    $status = get_post_meta( $ticketid, 'tps_status', true );
		    $assign = get_post_meta( $ticketid, 'tps_assign', true );
		    $feedback_status = get_post_meta( $ticketid, 'tps_feedback_status', true );
		    $post_author = get_post_field( 'post_author',  $ticketid);
		    $created_date = get_the_date('Y-m-d');

		    if(!isset($ticket_date_count[$created_date])){
		    	$ticket_date_count[$created_date] = 0;
		    }
		    $ticket_date_count[$created_date]++;

		    if($status == "new" || $status == ""){$ticket_status_count['new']++; }
		    else if($status == "open"){$ticket_status_count['open']++; }
		    else if($status == "pending"){$ticket_status_count['pending']++; }
		    else if($status == "solved"){$ticket_status_count['solved']++; }
		    else if($status == "closed"){$ticket_status_count['closed']++; }

		    if($feedback_status == "na" || $feedback_status == ""){$ticket_feedback_status_count['na']++; }
		    else if($feedback_status == "waiting"){$ticket_feedback_status_count['waiting']++; }
		    else if($feedback_status == "good"){$ticket_feedback_status_count['good']++; }
		    else if($feedback_status == "bad"){$ticket_feedback_status_count['bad']++; }
		    else if($feedback_status == "nofeedback"){$ticket_feedback_status_count['nofeedback']++; }

		    // entities
			
			$status_key = "status_".$status;
			if($status == ""){
				$status_key = "status_new";
			}

			$feedback_status_key = "feedback_status_".$feedback_status;
			if($feedback_status == ""){
				$feedback_status_key = "feedback_status_na";
			}

			if(isset($entities[$assign][$status_key])){
			    $entities[$assign][$status_key]++;
			}
			if(isset($entities[$assign][$feedback_status_key])){
		    	$entities[$assign][$feedback_status_key]++;
			}
			if(isset($entities[$assign]['tickets'])){
			    $entities[$assign]['tickets']++;
			}

			if(isset($entities[$post_author][$status_key])){
			    $entities[$post_author][$status_key]++;
			}

			if(isset($entities[$post_author][$feedback_status_key])){
		    	$entities[$post_author][$feedback_status_key]++;
		    }

			if(isset($entities[$post_author]['tickets'])){
			    $entities[$post_author]['tickets']++;
			}

		    /*echo "<pre>";
		    print_r($ticketid.$status.$assign.$feedback_status.$post_author);
		    echo "<br>";
		    echo "</pre>";*/


		endwhile;
		endif;
	}
	wp_reset_postdata();

	/*echo "<pre>";
	print_r($entities);
    echo "</pre>";*/


    echo "<div class='wrap'><h1 class='wp-heading-inline'>".__('Ticket Statistics','tpsupport')."</h1><div class='spacer'></div>";


    echo '<div class="tps-chart-container">
    		<h3>'.__('Ticket Status','tpsupport').'</h3>
              <div class="" style="height:300px" id="ticket_status_bar"></div>
      </div>';

    echo '<div class="tps-chart-container">
    		<h3>'.__('Ticket Feedback Status','tpsupport').'</h3>
              <div class="" style="height:300px" id="ticket_feedback_status_bar"></div>
      </div>';

    echo '<div class="tps-chart-container">
    		<h3>'.__('Ticket Created by Date','tpsupport').'</h3>
              <div class="" style="height:300px" id="ticket_date_area"></div>
      </div>';


    echo "<div class='spacer'></div><h1 class='wp-heading-inline'>".__('Agent Statistics','tpsupport')."</h1><div class='spacer'></div>";


    echo '<div class="tps-chart-container">
    		<h3>'.__('Agent&apos;s Ticket Statistics','tpsupport').'</h3>
              <div class="" style="height:300px" id="agents_ticket_status_bar"></div>
      </div>';

    echo '<div class="tps-chart-container">
    		<h3>'.__('Agent Group&apos;s Ticket Statistics','tpsupport').'</h3>
              <div class="" style="height:300px" id="agentgroups_ticket_status_bar"></div>
      </div>';

    echo '<div class="tps-chart-container">
    		<h3>'.__('Agent Group&apos;s Admin Ticket Statistics','tpsupport').'</h3>
              <div class="" style="height:300px" id="agentgroups_admin_ticket_status_bar"></div>
      </div>';

    echo '<div class="tps-chart-container">
    		<h3>'.__('Agent&apos;s Admin Ticket Statistics','tpsupport').'</h3>
              <div class="" style="height:300px" id="agentsadmin_ticket_status_bar"></div>
      </div>';



    echo "<div class='spacer'></div><h1 class='wp-heading-inline'>".__('Feedback Statistics','tpsupport')."</h1><div class='spacer'></div>";


    echo '<div class="tps-chart-container">
    		<h3>'.__('Agent&apos;s Ticket Feedback Statistics','tpsupport').'</h3>
              <div class="" style="height:300px" id="agents_ticket_feedback_bar"></div>
      </div>';

    echo '<div class="tps-chart-container">
    		<h3>'.__('Agent Group&apos;s Ticket Feedback Statistics','tpsupport').'</h3>
              <div class="" style="height:300px" id="agentgroups_ticket_feedback_bar"></div>
      </div>';

    echo '<div class="tps-chart-container">
    		<h3>'.__('Agent Group&apos;s Admin Ticket Feedback Statistics','tpsupport').'</h3>
              <div class="" style="height:300px" id="agentgroups_admin_ticket_feedback_bar"></div>
      </div>';

    echo '<div class="tps-chart-container">
    		<h3>'.__('Agent&apos;s Admin Ticket Feedback Statistics','tpsupport').'</h3>
              <div class="" style="height:300px" id="agentsadmin_ticket_feedback_bar"></div>
      </div>';




    echo "<div class='spacer'></div><h1 class='wp-heading-inline'>".__('Client Statistics','tpsupport')."</h1><div class='spacer'></div>";


    echo '<div class="tps-chart-container">
    		<h3>'.__('Client&apos;s Ticket Status','tpsupport').'</h3>
              <div class="" style="height:300px" id="clients_ticket_status_bar"></div>
      </div>';

    echo '<div class="tps-chart-container">
    		<h3>'.__('Client&apos;s Ticket Feedback Status','tpsupport').'</h3>
              <div class="" style="height:300px" id="clients_ticket_feedback_bar"></div>
      </div>';

      echo "</div>";


  /*--------------------------------------------------------*/
    //echo "<pre>"; print_r($ticket_date_count); echo "</pre>";
	$ticket_date_category = "";
	$ticket_date_value = "";
	foreach ($ticket_date_count as $dt => $tot) {
		if($dt != "" && $tot != "" && $tot != "0"){
			$ticket_date_category .= "'".$dt."',";
			$ticket_date_value .= "".$tot.",";
		}
	}
	$ticket_date_category = substr($ticket_date_category,0,-1);
	$ticket_date_value = substr($ticket_date_value,0,-1);

	//echo $ticket_date_value;
	//echo $ticket_date_category;


  /*--------------------------------------------------------*/
	$agents_status = $this->tps_get_assign_status('agents',$agents_arr,$entities);
	$agentgroups_status = $this->tps_get_assign_status('agentgroups',$agentgroups_arr,$entities);
	$agentgroups_admin_status = $this->tps_get_assign_status('agentgroups_admin',$agentgroups_admin_arr,$entities);
	$agentsadmin_status = $this->tps_get_assign_status('agentsadmin',$agentsadmin_arr,$entities);

	$agents_feedback = $this->tps_get_assign_feedback('agents',$agents_arr,$entities);
	$agentgroups_feedback = $this->tps_get_assign_feedback('agentgroups',$agentgroups_arr,$entities);
	$agentgroups_admin_feedback = $this->tps_get_assign_feedback('agentgroups_admin',$agentgroups_admin_arr,$entities);
	$agentsadmin_feedback = $this->tps_get_assign_feedback('agentsadmin',$agentsadmin_arr,$entities);

	$clients_status = $this->tps_get_assign_status('clients',$clients_arr,$entities);
	$clients_feedback = $this->tps_get_assign_feedback('clients',$clients_arr,$entities);


		$color = array();
		$color["color1"] = "#7986CB"; //indigo
		$color["color2"] = "#AED581"; // light green
		$color["color3"] = "#F06292"; //pink
		$color["color4"] = "#4DB6AC"; // teal
		$color["color5"] = "#81C784"; // green
		$color["color6"] = "#FFB74D"; // orange

		$nodataimg = plugins_url('/', __FILE__).'../../../../images/nodata.jpg';

	?>
	
	<script type="text/javascript">
		
		jQuery(document).ready(function($) { 

			if($("#ticket_status_bar").length){

			
			  <?php if($ticket_count > 0){ ?>
		      
		       // Initialize after dom ready
		       var myChart = echarts.init(document.getElementById('ticket_status_bar')); 
		        
		        var option = {

		                // Setup grid
		                grid: {
		                    zlevel: 0,
		                    x: 50,
		                    x2: 50,
		                    y: 20,
		                    y2: 20,
		                    borderWidth: 0,
		                    backgroundColor: 'rgba(0,0,0,0)',
		                    borderColor: 'rgba(0,0,0,0)',
		                },

		                // Add tooltip
		                tooltip: {
		                    trigger: 'axis',
		                    axisPointer: { 
		                        type: 'shadow', // line|shadow
		                        lineStyle:{color: 'rgba(0,0,0,.5)', width: 1},
		                        shadowStyle:{color: 'rgba(0,0,0,.1)'}
		                      }
		                },

		                // Add legend
		                legend: {
		                    data: []
		                },
		                toolbox: {
		                  orient: 'horizontal',
		                    show : true,
		                    showTitle: true,
		                    color : ['#999999','#999999','#999999','#999999'],
		                    feature : {
		                        mark : {show: false},
		                        dataZoom : {
		                            show : true,
		                            title : {
		                                dataZoom : '<?php echo __('Data Zoom','tpsupport'); ?>',
		                                dataZoomReset : '<?php echo __('Reset Zoom','tpsupport'); ?>'
		                            }
		                        },
		                        dataView : {show: false, readOnly: true},
		                        magicType : {
		                          show: true, 
		                          title : {
		                              line : '<?php echo __('Area','tpsupport'); ?>',
		                              bar : '<?php echo __('Bar','tpsupport'); ?>'
		                          },
		                          type: ['line', 'bar']
		                        },
		                        restore : {show: false},
		                        saveAsImage : {show: true,title:'<?php echo __('Save as Image','tpsupport'); ?>'}
		                    }
		                },

		                // Enable drag recalculate
		                calculable: true,

		                // Horizontal axis
		                xAxis: [{
		                    type: 'category',
		                    boundaryGap: false,
		                    data: ['<?php echo __('New','tpsupport'); ?>','<?php echo __('Open','tpsupport'); ?>','<?php echo __('Pending','tpsupport'); ?>','<?php echo __('Solved','tpsupport'); ?>','<?php echo __('Closed','tpsupport'); ?>'],
		                    axisLine: {
		                        show: true,
		                        onZero: true,
		                        lineStyle: {
		                            color: '#aaaaaa',
		                            type: 'solid',
		                            width: '2',
		                            shadowColor: 'rgba(0,0,0,0)',
		                            shadowBlur: 5,
		                            shadowOffsetX: 3,
		                            shadowOffsetY: 3,
		                        },
		                    },                    
		                    axisTick: {
		                        show: false,
		                    },
		                    splitLine: {
		                          show: false,
		                          lineStyle: {
		                              color: '#fff',
		                              type: 'solid',
		                              width: 0,
		                              shadowColor: 'rgba(0,0,0,0)',
		                        },
		                    },
		                }],

		                // Vertical axis
		                yAxis: [{
		                    type: 'value',
		                    splitLine: {
		                          show: false,
		                          lineStyle: {
		                              color: 'fff',
		                              type: 'solid',
		                              width: 0,
		                              shadowColor: 'rgba(0,0,0,0)',
		                        },
		                    },
		                    axisLabel: {
		                        show: false,
		                    },                    
		                    axisTick: {
		                        show: false,
		                    },                    
		                    axisLine: {
		                        show: false,
		                        onZero: true,
		                        lineStyle: {
		                            color: '#aaaaaa',
		                            type: 'solid',
		                            width: '0',
		                            shadowColor: 'rgba(0,0,0,0)',
		                            shadowBlur: 5,
		                            shadowOffsetX: 3,
		                            shadowOffsetY: 3,
		                        },
		                    },


		                }],

		                // Add series
		                series: [
		                    {
		                        name: '<?php echo __('Total Tickets','tpsupport'); ?>',
		                        type: 'bar',
		                        smooth: true,
		                        symbol:'none',
		                        symbolSize:2,
		                        showAllSymbol: true,
		                        itemStyle: {
		                          normal: {
		                            color:'<?php echo $color['color1']; ?>', 
		                            borderWidth:4, borderColor:'<?php echo $color['color1']; ?>', 
		                            areaStyle: {color:'<?php echo $color['color1']; ?>', type: 'default'}
		                          }
		                        },

		                        data: [<?php echo $ticket_status_count['new'].",".$ticket_status_count['open'].",".$ticket_status_count['pending'].",".$ticket_status_count['solved'].",".$ticket_status_count['closed']; ?>]
		                    }]
		            };

			        // Load data into the ECharts instance 
			        myChart.setOption(option); 

				<?php } else { ?> 
						
						$("#ticket_status_bar").html("<img src='<?php echo $nodataimg; ?>' class='echart-nodata'>");

				<?php } ?>


			}

		});


	</script>

	<script type="text/javascript">
		
		jQuery(document).ready(function($) { 

			if($("#ticket_feedback_status_bar").length){
		      
			
			  <?php if($ticket_count > 0){ ?>

		       // Initialize after dom ready
		       var myChart = echarts.init(document.getElementById('ticket_feedback_status_bar')); 
		        
		        var option = {

		                // Setup grid
		                grid: {
		                    zlevel: 0,
		                    x: 50,
		                    x2: 50,
		                    y: 20,
		                    y2: 20,
		                    borderWidth: 0,
		                    backgroundColor: 'rgba(0,0,0,0)',
		                    borderColor: 'rgba(0,0,0,0)',
		                },

		                // Add tooltip
		                tooltip: {
		                    trigger: 'axis',
		                    axisPointer: { 
		                        type: 'shadow', // line|shadow
		                        lineStyle:{color: 'rgba(0,0,0,.5)', width: 1},
		                        shadowStyle:{color: 'rgba(0,0,0,.1)'}
		                      }
		                },

		                // Add legend
		                legend: {
		                    data: []
		                },
		                toolbox: {
		                  orient: 'horizontal',
		                    show : true,
		                    showTitle: true,
		                    color : ['#999999','#999999','#999999','#999999'],
		                    feature : {
		                        mark : {show: false},
		                        dataZoom : {
		                            show : true,
		                            title : {
		                                dataZoom : '<?php echo __('Data Zoom','tpsupport'); ?>',
		                                dataZoomReset : '<?php echo __('Reset Zoom','tpsupport'); ?>'
		                            }
		                        },
		                        dataView : {show: false, readOnly: true},
		                        magicType : {
		                          show: true, 
		                          title : {
		                              line : '<?php echo __('Area','tpsupport'); ?>',
		                              bar : '<?php echo __('Bar','tpsupport'); ?>'
		                          },
		                          type: ['line', 'bar']
		                        },
		                        restore : {show: false},
		                        saveAsImage : {show: true,title:'<?php echo __('Save as Image','tpsupport'); ?>'}
		                    }
		                },

		                // Enable drag recalculate
		                calculable: true,

		                // Horizontal axis
		                xAxis: [{
		                    type: 'category',
		                    boundaryGap: false,
		                    data: ['<?php echo __('Email Not Sent','tpsupport'); ?>' ,'<?php echo __('Waiting','tpsupport'); ?>','<?php echo __('Good','tpsupport'); ?>','<?php echo __('Bad','tpsupport'); ?>','<?php echo __('No Feedback','tpsupport'); ?>'],
		                    axisLine: {
		                        show: true,
		                        onZero: true,
		                        lineStyle: {
		                            color: '#aaaaaa',
		                            type: 'solid',
		                            width: '2',
		                            shadowColor: 'rgba(0,0,0,0)',
		                            shadowBlur: 5,
		                            shadowOffsetX: 3,
		                            shadowOffsetY: 3,
		                        },
		                    },                    
		                    axisTick: {
		                        show: false,
		                    },
		                    splitLine: {
		                          show: false,
		                          lineStyle: {
		                              color: '#fff',
		                              type: 'solid',
		                              width: 0,
		                              shadowColor: 'rgba(0,0,0,0)',
		                        },
		                    },
		                }],

		                // Vertical axis
		                yAxis: [{
		                    type: 'value',
		                    splitLine: {
		                          show: false,
		                          lineStyle: {
		                              color: 'fff',
		                              type: 'solid',
		                              width: 0,
		                              shadowColor: 'rgba(0,0,0,0)',
		                        },
		                    },
		                    axisLabel: {
		                        show: false,
		                    },                    
		                    axisTick: {
		                        show: false,
		                    },                    
		                    axisLine: {
		                        show: false,
		                        onZero: true,
		                        lineStyle: {
		                            color: '#aaaaaa',
		                            type: 'solid',
		                            width: '0',
		                            shadowColor: 'rgba(0,0,0,0)',
		                            shadowBlur: 5,
		                            shadowOffsetX: 3,
		                            shadowOffsetY: 3,
		                        },
		                    },


		                }],

		                // Add series
		                series: [
		                    {
		                        name: '<?php echo __('Total Tickets','tpsupport'); ?>',
		                        type: 'bar',
		                        smooth: true,
		                        symbol:'none',
		                        symbolSize:2,
		                        showAllSymbol: true,
		                        itemStyle: {
		                          normal: {
		                            color:'<?php echo $color['color1']; ?>', 
		                            borderWidth:4, borderColor:'<?php echo $color['color1']; ?>', 
		                            areaStyle: {color:'<?php echo $color['color1']; ?>', type: 'default'}
		                          }
		                        },

		                        data: [<?php echo $ticket_feedback_status_count['na'].",".$ticket_feedback_status_count['waiting'].",".$ticket_feedback_status_count['good'].",".$ticket_feedback_status_count['bad'].",".$ticket_feedback_status_count['nofeedback']; ?>]
		                    }]
		            };

			        // Load data into the ECharts instance 
			        myChart.setOption(option); 
			
			<?php } else { ?> 
					
					$("#ticket_feedback_status_bar").html("<img src='<?php echo $nodataimg; ?>' class='echart-nodata'>");

			<?php } ?>
			

			}

		});


	</script>

		<script type="text/javascript">
			jQuery(document).ready(function($) { 
				if($("#ticket_date_area").length){
						
						<?php if($ticket_date_category != ""){ ?>
							       // Initialize after dom ready
							       var myChart = echarts.init(document.getElementById('ticket_date_area')); 
							        
							        var option = {

						                // Setup grid
						                grid: {
						                    zlevel: 0,
						                    x: 20,
						                    x2: 20,
						                    y: 20,
						                    y2: 20,
						                    borderWidth: 0,
						                    backgroundColor: 'rgba(0,0,0,0)',
						                    borderColor: 'rgba(0,0,0,0)',
						                },

						                // Add tooltip
						                tooltip: {
						                    trigger: 'axis',
						                    axisPointer: { 
						                        type: 'shadow', // line|shadow
						                        lineStyle:{color: 'rgba(0,0,0,.5)', width: 1},
						                        shadowStyle:{color: 'rgba(0,0,0,.1)'}
						                      }
						                },

						                // Add legend
						                legend: {
						                    data: []
						                },
						                toolbox: {
						                  orient: 'horizontal',
						                    show : true,
						                    showTitle: true,
						                    color : ['#999999','#999999','#999999','#999999'],
						                    feature : {
						                        mark : {show: false},
						                        dataZoom : {
						                            show : true,
						                            title : {
						                                dataZoom : '<?php echo __('Data Zoom','tpsupport'); ?>',
						                                dataZoomReset : '<?php echo __('Reset Zoom','tpsupport'); ?>'
						                            }
						                        },
						                        dataView : {show: false, readOnly: true},
						                        magicType : {
						                          show: true, 
						                          title : {
						                              line : '<?php echo __('Area','tpsupport'); ?>',
						                              bar : '<?php echo __('Bar','tpsupport'); ?>',
						                             // stack : 'Stacked Bar',
						                             // tiled: 'Tiled Bar'
						                          },
						                          type: ['line', 'bar',
						                          //'stack',
						                          //'tiled'
						                          ]
						                        },
						                        restore : {show: false},
						                        saveAsImage : {show: true,title:'<?php echo __('Save as Image','tpsupport'); ?>'}
						                    }
						                },

						                // Enable drag recalculate
						                calculable: true,

						                // Horizontal axis
						                xAxis: [{
						                    type: 'category',
						                    boundaryGap: false,
						                    data: [<?php echo $ticket_date_category; ?>],
						                    axisLine: {
						                        show: true,
						                        onZero: true,
						                        lineStyle: {
						                            color: '#aaaaaa',
						                            type: 'solid',
						                            width: '2',
						                            shadowColor: 'rgba(0,0,0,0)',
						                            shadowBlur: 5,
						                            shadowOffsetX: 3,
						                            shadowOffsetY: 3,
						                        },
						                    },                    
						                    axisTick: {
						                        show: false,
						                    },
						                    splitLine: {
						                          show: false,
						                          lineStyle: {
						                              color: '#fff',
						                              type: 'solid',
						                              width: 0,
						                              shadowColor: 'rgba(0,0,0,0)',
						                        },
						                    },
						                }],

						                // Vertical axis
						                yAxis: [{
						                    type: 'value',
						                    splitLine: {
						                          show: false,
						                          lineStyle: {
						                              color: 'fff',
						                              type: 'solid',
						                              width: 0,
						                              shadowColor: 'rgba(0,0,0,0)',
						                        },
						                    },
						                    axisLabel: {
						                        show: false,
						                    },                    
						                    axisTick: {
						                        show: false,
						                    },                    
						                    axisLine: {
						                        show: false,
						                        onZero: true,
						                        lineStyle: {
						                            color: '#aaaaaa',
						                            type: 'solid',
						                            width: '0',
						                            shadowColor: 'rgba(0,0,0,0)',
						                            shadowBlur: 5,
						                            shadowOffsetX: 3,
						                            shadowOffsetY: 3,
						                        },
						                    },


						                }],

						                // Add series
						                series: [
						                    {
						                        name: '<?php echo __('Tickets Created by Date','tpsupport'); ?>',
						                        type: 'line',
						                        smooth: true,
						                        symbol:'none',
						                        symbolSize:2,
						                        showAllSymbol: true,
						                        barWidth:15,
						                        barGap:'10%',
						                        itemStyle: {
						                          normal: {
						                            color:'<?php echo $color['color1']; ?>', 
						                            borderWidth:2, borderColor:'<?php echo $color['color1']; ?>', 
						                            areaStyle: {color:'<?php echo $color['color1']; ?>', type: 'default'}
						                          }
						                        },

						                        data: [<?php echo $ticket_date_value; ?>]
						                    },
						                ]
						            };

								        // Load data into the ECharts instance 
								        myChart.setOption(option); 

						<?php } else { ?>

							$("#ticket_date_area").html("<img src='<?php echo $nodataimg; ?>' class='echart-nodata'>");

						<?php } ?>

			} 
		});

		</script>


	<?php $this->tps_echart_agent_status('agents_ticket_status_bar',$agents_status,$color,$ticket_count,$nodataimg); ?>
	<?php $this->tps_echart_agent_status('agentgroups_ticket_status_bar',$agentgroups_status,$color,$ticket_count,$nodataimg); ?>
	<?php $this->tps_echart_agent_status('agentgroups_admin_ticket_status_bar',$agentgroups_admin_status,$color,$ticket_count,$nodataimg); ?>
	<?php $this->tps_echart_agent_status('agentsadmin_ticket_status_bar',$agentsadmin_status,$color,$ticket_count,$nodataimg); ?>


	<?php $this->tps_echart_agent_feedback('agents_ticket_feedback_bar',$agents_feedback,$color,$ticket_count,$nodataimg); ?>
	<?php $this->tps_echart_agent_feedback('agentgroups_ticket_feedback_bar',$agentgroups_feedback,$color,$ticket_count,$nodataimg); ?>
	<?php $this->tps_echart_agent_feedback('agentgroups_admin_ticket_feedback_bar',$agentgroups_admin_feedback,$color,$ticket_count,$nodataimg); ?>
	<?php $this->tps_echart_agent_feedback('agentsadmin_ticket_feedback_bar',$agentsadmin_feedback,$color,$ticket_count,$nodataimg); ?>


	<?php $this->tps_echart_agent_status('clients_ticket_status_bar',$clients_status,$color,$ticket_count,$nodataimg); ?>
	<?php $this->tps_echart_agent_feedback('clients_ticket_feedback_bar',$clients_feedback,$color,$ticket_count,$nodataimg); ?>



      <?php



	}


	function tps_echart_agent_status($id,$status_arr,$color,$ticket_count,$nodataimg){ 

		if(isset($status_arr['status_category']) && $status_arr['status_category'] != "" && $ticket_count > 0){

		


		$color1 = $color["color1"];
		$color2 = $color["color2"];
		$color3 = $color["color3"];
		$color4 = $color["color4"];
		$color5 = $color["color5"];
		$color6 = $color["color6"];

		 //echo "<pre>"; print_r($status_arr); echo "</pre>";
		?>

		<script type="text/javascript">
		
		jQuery(document).ready(function($) { 

			if($("#<?php echo $id; ?>").length){
		      
		       // Initialize after dom ready
		       var myChart = echarts.init(document.getElementById('<?php echo $id; ?>')); 
		        
		        var option = {

	                // Setup grid
	                grid: {
	                    zlevel: 0,
	                    x: 20,
	                    x2: 20,
	                    y: 20,
	                    y2: 20,
	                    borderWidth: 0,
	                    backgroundColor: 'rgba(0,0,0,0)',
	                    borderColor: 'rgba(0,0,0,0)',
	                },

	                // Add tooltip
	                tooltip: {
	                    trigger: 'axis',
	                    axisPointer: { 
	                        type: 'shadow', // line|shadow
	                        lineStyle:{color: 'rgba(0,0,0,.5)', width: 1},
	                        shadowStyle:{color: 'rgba(0,0,0,.1)'}
	                      }
	                },

	                // Add legend
	                legend: {
	                    data: []
	                },
	                toolbox: {
	                  orient: 'horizontal',
	                    show : true,
	                    showTitle: true,
	                    color : ['#999999','#999999','#999999','#999999'],
	                    feature : {
	                        mark : {show: false},
	                        dataZoom : {
	                            show : true,
	                            title : {
	                                dataZoom : '<?php echo __('Data Zoom','tpsupport'); ?>',
	                                dataZoomReset : '<?php echo __('Reset Zoom','tpsupport'); ?>'
	                            }
	                        },
	                        dataView : {show: false, readOnly: true},
	                        magicType : {
	                          show: true, 
	                          title : {
	                              line : '<?php echo __('Area','tpsupport'); ?>',
	                              bar : '<?php echo __('Bar','tpsupport'); ?>',
	                              stack : '<?php echo __('Stacked Bar','tpsupport'); ?>',
	                              tiled: '<?php echo __('Tiled Bar','tpsupport'); ?>',
	                          },
	                          type: ['line', 'bar', 'stack','tiled'
	                          ]
	                        },
	                        restore : {show: false},
	                        saveAsImage : {show: true,title:'<?php echo __('Save as Image','tpsupport'); ?>'}
	                    }
	                },

	                // Enable drag recalculate
	                calculable: true,

	                // Horizontal axis
	                yAxis: [{
	                    type: 'category',
	                    /*boundaryGap: false,*/
	                    data: [<?php echo $status_arr['status_category']; ?>],
	                    axisLine: {
	                        show: true,
	                        onZero: true,
	                        lineStyle: {
	                            color: '#aaaaaa',
	                            type: 'solid',
	                            width: '2',
	                            shadowColor: 'rgba(0,0,0,0)',
	                            shadowBlur: 5,
	                            shadowOffsetX: 3,
	                            shadowOffsetY: 3,
	                        },
	                    },                    
	                    axisTick: {
	                        show: false,
	                    },
	                    splitLine: {
	                          show: false,
	                          lineStyle: {
	                              color: '#fff',
	                              type: 'solid',
	                              width: 0,
	                              shadowColor: 'rgba(0,0,0,0)',
	                        },
	                    },
	                }],

	                // Vertical axis
	                xAxis: [{
	                    type: 'value',
	                    boundaryGap: false,
	                    splitLine: {
	                          show: false,
	                          lineStyle: {
	                              color: 'fff',
	                              type: 'solid',
	                              width: 0,
	                              shadowColor: 'rgba(0,0,0,0)',
	                        },
	                    },
	                    axisLabel: {
	                        show: false,
	                    },                    
	                    axisTick: {
	                        show: false,
	                    },                    
	                    axisLine: {
	                        show: false,
	                        onZero: true,
	                        lineStyle: {
	                            color: '#aaaaaa',
	                            type: 'solid',
	                            width: '0',
	                            shadowColor: 'rgba(0,0,0,0)',
	                            shadowBlur: 5,
	                            shadowOffsetX: 3,
	                            shadowOffsetY: 3,
	                        },
	                    },


	                }],

	                // Add series
	                series: [
	                    {
	                        name: '<?php echo __('Tickets','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color1; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color1; ?>', 
	                            areaStyle: {color:'<?php echo $color1; ?>', type: 'default'}
	                          }
	                        },
	                       
	                        data: [<?php echo $status_arr['status_tickets']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('New tickets','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color2; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color2; ?>', 
	                            areaStyle: {color:'<?php echo $color2; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $status_arr['status_new']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('Open tickets','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color3; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color3; ?>', 
	                            areaStyle: {color:'<?php echo $color3; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $status_arr['status_open']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('Pending tickets','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color4; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color4; ?>', 
	                            areaStyle: {color:'<?php echo $color4; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $status_arr['status_pending']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('Solved tickets','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color5; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color5; ?>', 
	                            areaStyle: {color:'<?php echo $color5; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $status_arr['status_solved']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('Closed tickets','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color6; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color6; ?>', 
	                            areaStyle: {color:'<?php echo $color6; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $status_arr['status_closed']; ?>]
	                    },
	                ]
	            };

			        // Load data into the ECharts instance 
			        myChart.setOption(option); 

			}

		});

		</script>

	<?php 

	} // end if
	else { ?>

			<script type="text/javascript">
		
			jQuery(document).ready(function($) {
				$("#<?php echo $id; ?>").html("<img src='<?php echo $nodataimg; ?>' class='echart-nodata'>");
			});

			</script>

	<?php	}

}




	function tps_echart_agent_feedback($id,$feedback_arr,$color,$ticket_count,$nodataimg){ 

		if(isset($feedback_arr['feedback_category']) && $feedback_arr['feedback_category'] != "" && $ticket_count > 0){

		

		$color1 = $color["color1"];
		$color2 = $color["color2"];
		$color3 = $color["color3"];
		$color4 = $color["color4"];
		$color5 = $color["color5"];
		$color6 = $color["color6"];

		// echo "<pre>"; print_r($feedback_arr); echo "</pre>";
		?>

		<script type="text/javascript">
		
		jQuery(document).ready(function($) { 

			if($("#<?php echo $id; ?>").length){
		      
		       // Initialize after dom ready
		       var myChart = echarts.init(document.getElementById('<?php echo $id; ?>')); 
		        
		        var option = {

	                // Setup grid
	                grid: {
	                    zlevel: 0,
	                    x: 20,
	                    x2: 20,
	                    y: 20,
	                    y2: 20,
	                    borderWidth: 0,
	                    backgroundColor: 'rgba(0,0,0,0)',
	                    borderColor: 'rgba(0,0,0,0)',
	                },

	                // Add tooltip
	                tooltip: {
	                    trigger: 'axis',
	                    axisPointer: { 
	                        type: 'shadow', // line|shadow
	                        lineStyle:{color: 'rgba(0,0,0,.5)', width: 1},
	                        shadowStyle:{color: 'rgba(0,0,0,.1)'}
	                      }
	                },

	                // Add legend
	                legend: {
	                    data: []
	                },
	                toolbox: {
	                  orient: 'horizontal',
	                    show : true,
	                    showTitle: true,
	                    color : ['#999999','#999999','#999999','#999999'],
	                    feature : {
	                        mark : {show: false},
	                        dataZoom : {
	                            show : true,
	                            title : {
	                                dataZoom : '<?php echo __('Data Zoom','tpsupport'); ?>',
	                                dataZoomReset : '<?php echo __('Reset Zoom','tpsupport'); ?>'
	                            }
	                        },
	                        dataView : {show: false, readOnly: true},
	                        magicType : {
	                          show: true, 
	                          title : {
	                              line : '<?php echo __('Area','tpsupport'); ?>',
	                              bar : '<?php echo __('Bar','tpsupport'); ?>',
	                              stack : '<?php echo __('Stacked Bar','tpsupport'); ?>',
	                              tiled: '<?php echo __('Tiled Bar','tpsupport'); ?>',
	                          },
	                          type: ['line', 'bar', 'stack','tiled'
	                          ]
	                        },
	                        restore : {show: false},
	                        saveAsImage : {show: true,title:'<?php echo __('Save as Image','tpsupport'); ?>'}
	                    }
	                },

	                // Enable drag recalculate
	                calculable: true,

	                // Horizontal axis
	                yAxis: [{
	                    type: 'category',
	                    /*boundaryGap: false,*/
	                    data: [<?php echo $feedback_arr['feedback_category']; ?>],
	                    axisLine: {
	                        show: true,
	                        onZero: true,
	                        lineStyle: {
	                            color: '#aaaaaa',
	                            type: 'solid',
	                            width: '2',
	                            shadowColor: 'rgba(0,0,0,0)',
	                            shadowBlur: 5,
	                            shadowOffsetX: 3,
	                            shadowOffsetY: 3,
	                        },
	                    },                    
	                    axisTick: {
	                        show: false,
	                    },
	                    splitLine: {
	                          show: false,
	                          lineStyle: {
	                              color: '#fff',
	                              type: 'solid',
	                              width: 0,
	                              shadowColor: 'rgba(0,0,0,0)',
	                        },
	                    },
	                }],

	                // Vertical axis
	                xAxis: [{
	                    type: 'value',
	                    /*boundaryGap: false,*/
	                    splitLine: {
	                          show: false,
	                          lineStyle: {
	                              color: 'fff',
	                              type: 'solid',
	                              width: 0,
	                              shadowColor: 'rgba(0,0,0,0)',
	                        },
	                    },
	                    axisLabel: {
	                        show: false,
	                    },                    
	                    axisTick: {
	                        show: false,
	                    },                    
	                    axisLine: {
	                        show: false,
	                        onZero: true,
	                        lineStyle: {
	                            color: '#aaaaaa',
	                            type: 'solid',
	                            width: '0',
	                            shadowColor: 'rgba(0,0,0,0)',
	                            shadowBlur: 5,
	                            shadowOffsetX: 3,
	                            shadowOffsetY: 3,
	                        },
	                    },


	                }],

	                // Add series
	                series: [
	                    {
	                        name: '<?php echo __('Tickets','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color1; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color1; ?>', 
	                            areaStyle: {color:'<?php echo $color1; ?>', type: 'default'}
	                          }
	                        },
	                       
	                        data: [<?php echo $feedback_arr['feedback_tickets']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('Email Not Sent','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color2; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color2; ?>', 
	                            areaStyle: {color:'<?php echo $color2; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $feedback_arr['feedback_na']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('Waiting for Feedback','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color3; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color3; ?>', 
	                            areaStyle: {color:'<?php echo $color3; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $feedback_arr['feedback_waiting']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('Good','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color4; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color4; ?>', 
	                            areaStyle: {color:'<?php echo $color4; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $feedback_arr['feedback_good']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('Bad','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color5; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color5; ?>', 
	                            areaStyle: {color:'<?php echo $color5; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $feedback_arr['feedback_bad']; ?>]
	                    },
	                    {
	                        name: '<?php echo __('No Feedback','tpsupport'); ?>',
	                        type: 'bar',
	                        smooth: true,
	                        symbol:'none',
	                        symbolSize:2,
	                        showAllSymbol: true,
	                        barWidth:15,
	                        barGap:'10%',
	                        itemStyle: {
	                          normal: {
	                            color:'<?php echo $color6; ?>', 
	                            borderWidth:2, borderColor:'<?php echo $color6; ?>', 
	                            areaStyle: {color:'<?php echo $color6; ?>', type: 'default'}
	                          }
	                        },
	                        data: [<?php echo $feedback_arr['feedback_nofeedback']; ?>]
	                    },
	                ]
	            };

			        // Load data into the ECharts instance 
			        myChart.setOption(option); 

			}

		});

		</script>

	<?php 

	} // end if
	else { ?>

			<script type="text/javascript">
		
			jQuery(document).ready(function($) {
				$("#<?php echo $id; ?>").html("<img src='<?php echo $nodataimg; ?>' class='echart-nodata'>");
			});

			</script>

	<?php	}



}




	function tps_declare_array($arr){

		foreach ($arr as $id => $value) {
	    	$arr[$id]['id'] = $id;
	    	$arr[$id]['name'] = $value['name'];
	    	$arr[$id]['tickets'] = 0;

	    	$arr[$id]['status_new'] = 0;
	    	$arr[$id]['status_open'] = 0;
	    	$arr[$id]['status_pending'] = 0;
	    	$arr[$id]['status_solved'] = 0;
	    	$arr[$id]['status_closed'] = 0;

	    	$arr[$id]['feedback_status_na'] = 0;
	    	$arr[$id]['feedback_status_waiting'] = 0;
	    	$arr[$id]['feedback_status_good'] = 0;
	    	$arr[$id]['feedback_status_bad'] = 0;
	    	$arr[$id]['feedback_status_nofeedback'] = 0;
	    }
	    return $arr;
	}

	function tps_merge_all_array($agents_count,$agentgroups_count,$agentgroups_admin_count,$agentsadmin_count,$clients_count){

		$ret = array();
		foreach ($agents_count as $key => $value) {
			$value['type'] = "agent";
			$ret[$key] = $value;
		}
		foreach ($agentgroups_count as $key => $value) {
			$value['type'] = "agentgroup";
			$ret[$key] = $value;
		}
		foreach ($agentgroups_admin_count as $key => $value) {
			$value['type'] = "agentgroup_admin";
			$ret[$key] = $value;
		}
		foreach ($agentsadmin_count as $key => $value) {
			$value['type'] = "agentadmin";
			$ret[$key] = $value;
		}
		foreach ($clients_count as $key => $value) {
			$value['type'] = "client";
			$ret[$key] = $value;
		}
		return $ret;

	}


function tps_get_assign_status($type,$arr,$entities){

	$ret = array();
	$ret['status_tickets'] = "";
	$ret['status_new'] = "";
	$ret['status_open'] = "";
	$ret['status_pending'] = "";
	$ret['status_solved'] = "";
	$ret['status_closed'] = "";
	$ret['status_category'] = "";

	foreach ($arr as $id => $name) {

		/*echo $entities[$id]['id']."<br>";
		echo $entities[$id]['name']."<br>";
		echo $entities[$id]['tickets']."<br>";
		echo $entities[$id]['status_new']."<br>";
		echo $entities[$id]['status_open']."<br>";
		echo $entities[$id]['status_pending']."<br>";
		echo $entities[$id]['status_solved']."<br>";
		echo $entities[$id]['status_closed']."<hr>";*/

		$ret['status_category'] .= "'".$entities[$id]['name']."',";
		$ret['status_tickets'] .= "".$entities[$id]['tickets'].",";
		$ret['status_new'] .= "".$entities[$id]['status_new'].",";
		$ret['status_open'] .= "".$entities[$id]['status_open'].",";
		$ret['status_pending'] .= "".$entities[$id]['status_pending'].",";
		$ret['status_solved'] .= "".$entities[$id]['status_solved'].",";
		$ret['status_closed'] .= "".$entities[$id]['status_closed'].",";

	}

	$ret['status_category'] = substr($ret['status_category'],0,-1);
	$ret['status_tickets'] = substr($ret['status_tickets'],0,-1);
	$ret['status_new'] = substr($ret['status_new'],0,-1);
	$ret['status_open'] = substr($ret['status_open'],0,-1);
	$ret['status_pending'] = substr($ret['status_pending'],0,-1);
	$ret['status_solved'] = substr($ret['status_solved'],0,-1);
	$ret['status_closed'] = substr($ret['status_closed'],0,-1);

	/*echo $ret['status_new']."<br>";
	echo $ret['status_open']."<br>";
	echo $ret['status_pending']."<br>";
	echo $ret['status_solved']."<br>";
	echo $ret['status_closed']."<br>";
	echo $ret['status_tickets']."<br>";
	echo $ret['status_category']."<br>";*/
	return $ret;
}



function tps_get_assign_feedback($type,$arr,$entities){

	$ret = array();
	$ret['feedback_tickets'] = "";
	$ret['feedback_na'] = "";
	$ret['feedback_waiting'] = "";
	$ret['feedback_good'] = "";
	$ret['feedback_bad'] = "";
	$ret['feedback_nofeedback'] = "";
	$ret['feedback_category'] = "";

	foreach ($arr as $id => $name) {

		/*echo $entities[$id]['id']."<br>";
		echo $entities[$id]['name']."<br>";
		echo $entities[$id]['tickets']."<br>";
		echo $entities[$id]['feedback_na']."<br>";
		echo $entities[$id]['feedback_waiting']."<br>";
		echo $entities[$id]['feedback_good']."<br>";
		echo $entities[$id]['feedback_bad']."<br>";
		echo $entities[$id]['feedback_nofeedback']."<hr>";*/

		$ret['feedback_category'] .= "'".$entities[$id]['name']."',";
		$ret['feedback_tickets'] .= "".$entities[$id]['tickets'].",";
		$ret['feedback_na'] .= "".$entities[$id]['feedback_status_na'].",";
		$ret['feedback_waiting'] .= "".$entities[$id]['feedback_status_waiting'].",";
		$ret['feedback_good'] .= "".$entities[$id]['feedback_status_good'].",";
		$ret['feedback_bad'] .= "".$entities[$id]['feedback_status_bad'].",";
		$ret['feedback_nofeedback'] .= "".$entities[$id]['feedback_status_nofeedback'].",";

	}

	$ret['feedback_category'] = substr($ret['feedback_category'],0,-1);
	$ret['feedback_tickets'] = substr($ret['feedback_tickets'],0,-1);
	$ret['feedback_na'] = substr($ret['feedback_na'],0,-1);
	$ret['feedback_waiting'] = substr($ret['feedback_waiting'],0,-1);
	$ret['feedback_good'] = substr($ret['feedback_good'],0,-1);
	$ret['feedback_bad'] = substr($ret['feedback_bad'],0,-1);
	$ret['feedback_nofeedback'] = substr($ret['feedback_nofeedback'],0,-1);

	/*echo $ret['feedback_na']."<br>";
	echo $ret['feedback_waiting']."<br>";
	echo $ret['feedback_good']."<br>";
	echo $ret['feedback_bad']."<br>";
	echo $ret['feedback_nofeedback']."<br>";
	echo $ret['feedback_tickets']."<br>";
	echo $ret['feedback_category']."<br>";*/
	return $ret;
}


	function tps_get_settings_sections() {
		$sections = array(
			array(
				'id' => 'front_form_settings',
				'title' => __( 'Basic Settings', 'tpsupport' ),
			),
			array(
				'id' => 'messages_settings',
				'title' => __( 'Messages', 'tpsupport' ),
			),
			/*array(
				'id' => 'form_settings',
				'title' => __( 'Form', 'tpsupport' ),
			),*/
			/*array(
				'id' => 'imap_settings',
				'title' => __( 'Imap Email Account', 'tpsupport' ),
			),*/
			array(
				'id' => 'pages_settings',
				'title' => __( 'Pages & Redirects', 'tpsupport' ),
			),
			array(
				'id' => 'userfeedback_settings',
				'title' => __( 'User Feedback', 'tpsupport' ),
			),
			array(
				'id' => 'assign_agent_settings',
				'title' => __( 'Assign Agent', 'tpsupport' ),
			),
			array(
				'id' => 'notification_settings',
				'title' => __( 'Notifications', 'tpsupport' ),
			),
			array(
				'id' => 'email_settings',
				'title' => __( 'Email & IMAP Settings', 'tpsupport' ),
			),
			/*array(
				'id' => 'test_field_settings',
				'title' => __( 'Test Field', 'tpsupport' ),
			),*/


		);
		return $sections;
	}

	/**
	 * Returns all the settings fields
	 *
	 * @return array settings fields
	 */
	static function tps_get_settings_fields() {

		$pages_arr = tps_get_all_pages();
		$pages_sel = tps_add_pre_options($pages_arr,'select',false);
		$pages_same = tps_add_pre_options($pages_arr,'',true);

		//print_r($pages_arr); echo "<br>"; print_r($pages_sel); die;
		//echo "<pre>"; print_r(self::tps_get_post_types()); echo "</pre>";

		$default_post_type = array( 'tickets' => 'Tickets' );
		$settings_fields = array(
			/*'test_field_settings' => array(
				array(
					'name' => 'tps_test_message',
					'label' => __( 'New user welcome email - Message', 'tpsupport' ),
					'desc' => __( 'URL of your blog.', 'tpsupport' ),
					'type' => 'textarea',
					'default' => __('Thank you for registering on %BLOGNAME%.
						<br>The team at %BLOGNAME%','tpsupport'),
				),
				),*/

			'front_form_settings' => array(
				/*array(
					'name' => 'enable_akismet_protection',
					'label' => __( 'Enable Akismet spam protection', 'tpsupport' ),
					'desc' => __( 'Yes (Akismet must be enabled and configured)', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => '',
				),*/
				/*array(
					'name' => 'enable_recaptcha_protection',
					'label' => __( 'Enable Recaptcha spam protection', 'tpsupport' ),
					'desc' => __( 'Yes (Fill in Recaptcha credentials below)', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => '',
				),
				array(
					'name' => 'recaptcha_site_key',
					'label' => __( 'Recaptcha Site Key', 'tpsupport' ) . " get at https://www.google.com/recaptcha/admin",
					'desc' => '',
					'type' => 'text',
					'default' => '',
				),
				array(
					'name' => 'recaptcha_secret_key',
					'label' => __( 'Recaptcha Site Secret', 'tpsupport' ) . " get at https://www.google.com/recaptcha/admin",
					'desc' => '',
					'type' => 'text',
					'default' => '',
				),*/

				/*array(
					'name' => 'show_author',
					'label' => __( 'Show author field', 'tpsupport' ),
					'desc' => __( 'Yes', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => '',
				),*/
				/*array(
					'name' => 'enabled_post_types',
					'label' => __( 'Enable Frontend Uploader for the following post types', 'tpsupport' ),
					'desc' => '',
					'type' => 'multicheck',
					'default' => $default_post_type,
					'options' => self::tps_get_post_types(),
				),*/
				array(
					'name' => 'tps_enable_captcha_register',
					'label' => __('Captcha on registration form', 'tpsupport' ),
					'desc' => __( 'Enable captcha at the time of registration.', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				array(
					'name' => 'tps_enable_captcha_ticket',
					'label' => __('Captcha on new ticket form', 'tpsupport' ),
					'desc' => __( 'Enable captcha at new ticket creation form.', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				array(
					'name' => 'tps_enable_captcha_comment',
					'label' => __('Captcha on ticket comment form', 'tpsupport' ),
					'desc' => __( 'Enable captcha at view ticket comment form.', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				array(
					'name' => 'tps_enable_captcha_feedback',
					'label' => __('Captcha on ticket feedback form', 'tpsupport' ),
					'desc' => __( 'Enable captcha at ticket feedback form.', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				array(
					'name' => 'tps_enable_forgot_password',
					'label' => __('forgot password link on login form', 'tpsupport' ),
					'desc' => __( 'Select to Enable forgot password link on login form.', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				array(
					'name' => 'wysiwyg_enabled',
					'label' => __( 'Enable visual editor for description field in forms', 'tpsupport' ),
					'desc' => __( 'Yes', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				array(
					'name' => 'enabled_files',
					'label' => __( 'Also allow to upload these files (in addition to the ones that WP allows by default)', 'tpsupport' ),
					'desc' => '',
					'type' => 'multicheck',
					'default' => array(),
					'options' => tps_get_exts_descs(),
				),
				/*array(
					'name' => 'auto_approve_user_files',
					'label' => __( 'Auto-approve registered users files', 'tpsupport' ),
					'desc' => __( 'Auto approve any files uploaded by registered users as ticket attachments', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				array(
					'name' => 'auto_approve_any_files',
					'label' => __( 'Auto-approve any files', 'tpsupport' ),
					'desc' => __( 'Auto approve any files uploaded by any user as ticket attachments', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),*/
				array(
					'name' => 'obfuscate_file_name',
					'label' => __( 'Obfuscate file name', 'tpsupport' ),
					'desc' => __( 'Obfuscate file names of ticket attachments (if any)', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				array(
					'name' => 'allow_agent_frontend_reassign',
					'label' => __( 'Assign agent from front end', 'tpsupport' ),
					'desc' => __( 'Allow Agent Admin, Agent Group Admin or Site Administrator to reassign tickets to other agents from frontend on ticket details page.', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				/*array(
					'name' => 'enable_faq',
					'label' => __( 'Enable FAQ section', 'tpsupport' ),
					'desc' => __( 'Select to show FAQ module on your site', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),*/
				/*array(
					'name' => 'enable_agent_groups',
					'label' => __( 'Enable Agent Groups', 'tpsupport' ),
					'desc' => __( 'Select to add ability to create agent groups', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),*/

				array(
					'name' => 'auto_close_time',
					'label' => __( 'Enter Days to Auto Close a Solved Ticket', 'tpsupport' ),
					'desc' => __( 'If User Feedback/Rating is disabled, Auto Close ticket after these number of days, once it is marked as solved. Time is in days. Default is 3 days', 'tpsupport' ),
					'type' => 'text',
					'default' => '3',
				),

				/*array(
					'name' => 'suppress_default_fields',
					'label' => __('Suppress default fields', 'tpsupport' ),
					'desc' => __( 'Yes', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => '',
				),*/

			),
			'email_settings' => array(
				
				array(
					'name' => 'tps_imap_hostname',
					'label' => __( 'Email Account - IMAP Host', 'tpsupport' ),
					'desc' => __( 'IMAP Hostname of your email account, where you receive all the ticket replies as emails from user', 'tpsupport' ),
					'type' => 'text',
					'default' => '{imap.gmail.com:993/imap/ssl}inbox',
				),
				array(
					'name' => 'tps_imap_username',
					'label' => __( 'Email Account - IMAP Email', 'tpsupport' ),
					'desc' => __( 'IMAP Email Account Username', 'tpsupport' ),
					'type' => 'text',
					'default' => 'youremail@example.com',
				),
				array(
					'name' => 'tps_imap_password',
					'label' => __( 'Email Account - IMAP Password', 'tpsupport' ),
					'desc' => __( 'IMAP Email Account Password. Leave blank to keep unchanged.', 'tpsupport' ),
					'type' => 'password',
					'default' => '',
				),

				array(
					'name' => 'tps_imap_email_frequency',
					'label' => __( 'Fetch Email Frequency', 'tpsupport' ),
					'desc' => __( 'All the latest emails received in last number of seconds. Cron job to fetch the email replies should be same as this time. Time is in seconds. Default: 300 (5 minutes)', 'tpsupport' ),
					'type' => 'text',
					'default' => '300',
				),
				array(
					'name' => 'tps_user_email_confirmation',
					'label' => __( 'Enable New User Email Confirmation', 'tpsupport' ),
					'desc' => __( 'Use this feature, if you want to make sure new user must confirm his/her email address at the time of registration.', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),

				array(
					'name' => 'tps_notification_subject',
					'label' => __( 'New user welcome email - Subject', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with the name of your blog.', 'tpsupport' ),
					'type' => 'text',
					'default' => __('Welcome to %BLOGNAME%','tpsupport'),
				),


				array(
					'name' => 'tps_notification_message',
					'label' => __( 'New user welcome email - Message', 'tpsupport' ),
					'desc' => __( '<code>%FIRSTNAME%</code> will be replaced with a user&apos;s first name.<br><code>%LASTNAME%</code> will be replaced with a user&apos;s last name.<br><code>%USERNAME%</code> will be replaced with a user&apos;s username.<br><code>%USEREMAIL%</code> will be replaced with a user&apos;s email.<br><code>%BLOGNAME%</code> will be replaced with a name of your site.<br><code>%BLOGURL%</code> will be replaced with a URL of your blog.', 'tpsupport' ),
					'type' => 'textarea',
					'default' => __('Thank you for registering on %BLOGNAME%.
			<br><br>
			<strong>First Name :</strong> %FIRSTNAME%<br>
			<strong>Last Name : </strong>%LASTNAME%<br>
			<strong>Username :</strong> %USERNAME%<br>
			<strong>Email :</strong> %USEREMAIL%<br>
			<strong>Password :</strong> As choosen at the time of registration.
			<br><br>
			Please visit %BLOGURL% to login.
			<br><br>
			Thank You,
			<br>
			The team at %BLOGNAME%','tpsupport'),
				),


				array(
					'name' => 'tps_new_account_verification_email_subject',
					'label' => __( 'New Account verification email - Subject', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with the name of your blog.', 'tpsupport' ),
					'type' => 'text',
					'default' => __('%BLOGNAME% | Please confirm your email','tpsupport'),
				),


				array(
					'name' => 'tps_new_account_verification_email_message',
					'label' => __( 'New Account verification email - Message', 'tpsupport' ),
					'desc' => __( '<code>%VERIFICATIONLINK%</code> will be replaced with a new account activation link.<br><code>%BLOGNAME%</code> will be replaced with a name of your site.<br><code>%BLOGURL%</code> will be replaced with a URL of your blog.', 'tpsupport' ),
					'type' => 'textarea',
					'default' => __('Thank you for registering on %BLOGNAME%.
			<br><br>
			Please confirm your email by clicking on below link :
			<br><br>
			%VERIFICATIONLINK%
			<br><br>
			Thank You,
			<br>
			The team at %BLOGNAME%','tpsupport'),
				),





				array(
					'name' => 'tps_notification_to_admin_subject',
					'label' => __( 'New user Registered Notification to Site Admin - Subject', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with the name of your blog.', 'tpsupport' ),
					'type' => 'text',
					'default' => __('%BLOGNAME% | New User Registered','tpsupport'),
				),


				array(
					'name' => 'tps_notification_to_admin_message',
					'label' => __( 'New user Registered Notification to Site Admin - Message', 'tpsupport' ),
					'desc' => __( '<code>%FIRSTNAME%</code> will be replaced with a user&apos;s first name.<br><code>%LASTNAME%</code> will be replaced with a user&apos;s last name.<br><code>%USERNAME%</code> will be replaced with a user&apos;s username.<br><code>%USEREMAIL%</code> will be replaced with a user&apos;s email.<br><code>%BLOGNAME%</code> will be replaced with a name of your site.<br><code>%BLOGURL%</code> will be replaced with a URL of your blog.', 'tpsupport' ),
					'type' => 'textarea',
					'default' => __('New User Registered on %BLOGNAME%. Here are the details below:
			<br><br>
			<strong>First Name :</strong> %FIRSTNAME%<br>
			<strong>Last Name : </strong>%LASTNAME%<br>
			<strong>Username :</strong> %USERNAME%<br>
			<strong>Email :</strong> %USEREMAIL%<br>
			<br><br>
			Thank You','tpsupport'),
				),








				array(
					'name' => 'tps_password_reset_email_subject',
					'label' => __( 'Password Reset Email - Subject', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with the name of your blog.', 'tpsupport' ),
					'type' => 'text',
					'default' => __('%BLOGNAME% | Password Reset','tpsupport'),
				),


				array(
					'name' => 'tps_password_reset_email_message',
					'label' => __( 'Password Reset Email - Message', 'tpsupport' ),
					'desc' => __( '<code>%RECOVERYLINK%</code> will be replaced with a password recovery link.<br><code>%BLOGNAME%</code> will be replaced with a name of your site.<br><code>%USERNAME%</code> will be replaced with a username.', 'tpsupport' ),
					'type' => 'textarea',
					'default' => __('Hello %USERNAME%,
			<br><br>
			We have received a request to change your password.
			Click on the link to change your password : 
			<br><br>
			%RECOVERYLINK%
			<br><br>
			Thank You,
			<br>
			The team at %BLOGNAME%','tpsupport'),
				),





				array(
					'name' => 'tps_new_ticket_generated_admin_notification_subject',
					'label' => __( 'New Ticket Generated - Admin Notification email - Subject', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with the name of your blog.', 'tpsupport' ),
					'type' => 'text',
					'default' => __('%BLOGNAME% | New Support Ticket was Generated','tpsupport'),
				),


				array(
					'name' => 'tps_new_ticket_generated_admin_notification_message',
					'label' => __( 'New Ticket Generated - Admin Notification email - Message', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with a name of your site.<br>
						<code>%TICKETID%</code> will be replaced with the created ticket id.<br>
						<code>%TICKETURL%</code> will be replaced with the created ticket access URL.<br>
						<code>%NAME%</code> will be replaced with a Full name on ticket creator.<br>
						<code>%USERNAME%</code> will be replaced with a username of user, if registered.<br>
						<code>%USEREMAIL%</code> will be replaced with a email of user to be used for further communication.<br>
						<code>%TOPIC%</code> will be replaced with a ticket topic.<br>
						<code>%TITLE%</code> will be replaced with a Ticket title.<br>
						<code>%CONTENT%</code> will be replaced with a ticket content.<br>
						<code>%ATTACHMENTS%</code> will be replaced list of files attached (if any) in ticket.<br>
						<code>%RELEVANTURL%</code> will be replaced with a Relevant URL (if any) added in ticket.', 'tpsupport' ),
					'type' => 'textarea',
					'default' => __('Details of New Ticket Generated on %BLOGNAME% are as below:

			<br><br>

			<strong>Ticket ID :</strong> %TICKETID%<br>

			<strong>Ticket Access URL :</strong> %TICKETURL%<br>

			<strong>Name :</strong> %NAME%<br>

			<strong>Username :</strong> %USERNAME%<br>

			<strong>Email :</strong> %USEREMAIL%<br>

			<strong>Topic :</strong> %TOPIC%<br>

			<strong>Title :</strong> %TITLE%<br>

			<strong>Content :</strong> %CONTENT%<br>

			<strong>Relevant URL :</strong> %RELEVANTURL%<br>
			<strong>Attachments :</strong> %ATTACHMENTS%<br>
			Thank You
			','tpsupport'),
				),


				array(
					'name' => 'tps_new_ticket_generated_user_notification_subject',
					'label' => __( 'New Ticket Generated - Notification Email to Ticket Creator - Subject', 'tpsupport' ),
					'desc' => __( 'This is the email subject of generated ticket email notification. All the emails having this string in subject will be fetched and processed further to fetch email replies. Ticket id will be appended to this text in email subject.', 'tpsupport' ),
					'type' => 'text',
					'default' => 'Your Ticket ID',
				),

				array(
					'name' => 'tps_new_ticket_generated_user_notification_replyabove',
					'label' => __( 'Email Reply Above Text', 'tpsupport' ),
					'desc' => __( 'All the content above this line in the email will be fetched as ticket comment while fetching ticket comments from emails. Also this line will be prepended to email sent to ticket creator.', 'tpsupport' ),
					'type' => 'text',
					'default' => '## Please type your reply above this line ##',
				),

				array(
					'name' => 'tps_new_ticket_generated_user_notification_message',
					'label' => __( 'New Ticket Generated - Notification Email to Ticket Creator  - Message', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with a name of your site.<br>
						<code>%TICKETID%</code> will be replaced with the created ticket id.<br>
						<code>%TICKETURL%</code> will be replaced with the created ticket access URL.<br>
						<code>%NAME%</code> will be replaced with a Full name on ticket creator.<br>
						<code>%USERNAME%</code> will be replaced with a username of user, if registered.<br>
						<code>%USEREMAIL%</code> will be replaced with a email of user to be used for further communication.<br>
						<code>%TOPIC%</code> will be replaced with a ticket topic.<br>
						<code>%TITLE%</code> will be replaced with a Ticket title.<br>
						<code>%CONTENT%</code> will be replaced with a ticket content.<br>
						<code>%ATTACHMENTS%</code> will be replaced list of files attached (if any) in ticket.<br>
						<code>%RELEVANTURL%</code> will be replaced with a Relevant URL (if any) added in ticket.', 'tpsupport' ),
					'type' => 'textarea',
					'default' => __('Details of New Ticket Generated on %BLOGNAME% are as below:
			<br><br>
			<strong>Ticket ID :</strong> %TICKETID%<br>
			<strong>Ticket Access URL :</strong> %TICKETURL%<br>
			<strong>Name :</strong> %NAME%<br>
			<strong>Email :</strong> %USEREMAIL%<br>
			<strong>Topic :</strong> %TOPIC%<br>
			<strong>Title :</strong> %TITLE%<br>
			<strong>Content :</strong> %CONTENT%<br>
			<strong>Relevant URL :</strong> %RELEVANTURL%<br>
			<strong>Attachments :</strong> %ATTACHMENTS%<br><br>
			One of our agent will get in touch with you shortly.<br>
			Thank You,
			<br>
			The team at %BLOGNAME%
			','tpsupport'),
				),



				array(
					'name' => 'tps_new_comment_generated_user_notification_message',
					'label' => __( 'New Comment Posted on Ticket - Notification Email to Ticket Creator  - Message', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with a name of your site.<br>
						<code>%TICKETID%</code> will be replaced with the created ticket id.<br>
						<code>%TICKETURL%</code> will be replaced with the created ticket access URL.<br>
						<code>%NAME%</code> will be replaced with a Full name on ticket creator.<br>
						<code>%USERNAME%</code> will be replaced with a username of user, if registered.<br>
						<code>%USEREMAIL%</code> will be replaced with a email of user to be used for further communication.<br>
						<code>%TOPIC%</code> will be replaced with a ticket topic.<br>
						<code>%TITLE%</code> will be replaced with a Ticket title.<br>
						<code>%CONTENT%</code> will be replaced with a ticket content.<br>
						<code>%ATTACHMENTS%</code> will be replaced list of files attached (if any) in ticket.<br>
						<code>%RELEVANTURL%</code> will be replaced with a Relevant URL (if any) added in ticket.', 'tpsupport' ),
					'type' => 'textarea',
					'default' => __('New Comment is posted on your Ticket on %BLOGNAME%. Below are its details:

			<br><br>
			<strong>Ticket ID :</strong> %TICKETID%<br>

			<strong>Ticket Access URL :</strong> %TICKETURL%<br>

			<strong>Posted By :</strong> %NAME%<br>

			<strong>Content :</strong> %CONTENT%<br>

			<strong>Attachments :</strong> %ATTACHMENTS%<br><br>

			','tpsupport'),
				),

				array(
					'name' => 'feedback_email_subject',
					'label' => __( 'User Feedback Email - Subject', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with the name of your blog.', 'tpsupport' ),
					'type' => 'text',
					'default' => __('%BLOGNAME% | How would you rate the support received for your ticket?','tpsupport'),
				),


				array(
					'name' => 'feedback_email_message',
					'label' => __( 'User Feedback Email - Message', 'tpsupport' ),
					'desc' => __( '<code>%BLOGNAME%</code> will be replaced with a name of your site.<br>
						<code>%TICKETID%</code> will be replaced with the created ticket id.<br>
						<code>%GOODURL%</code> will be replaced with the ticket rating page URL for positive/good rating.<br>
						<code>%BADURL%</code> will be replaced with the ticket rating page URL for negative/bad rating.<br>
						<code>%TICKETURL%</code> will be replaced with the created ticket access URL.<br>
						<code>%NAME%</code> will be replaced with a Full name on ticket creator.<br>
						<code>%TOPIC%</code> will be replaced with a ticket topic.<br>
						<code>%TITLE%</code> will be replaced with a Ticket title.<br>
						<code>%CONTENT%</code> will be replaced with a ticket content.<br>', 'tpsupport' ),
					'type' => 'textarea',
					'default' => __('Hello %NAME%,

			<br><br>We would love to get your feedback on how would you rate the support received. To give your feedback please click on any of these links below <br><br><a href="%GOODURL%">Good. I am satisfied. </a><br><br><a href="%BADURL%">Bad. I am unsatisfied.</a><br><br>If your request is not solved yet, then you can visit the ticket detail page from the url below and post a reply.<br><br><a href="%TICKETURL%">Not Resolved Yet?</a><br><hr><br>Following are the details of your support ticket:<br><br>

			<strong>Ticket ID :</strong> %TICKETID%<br>

			<strong>Title :</strong> %TITLE%<br>

			<strong>Ticket Access URL :</strong> %TICKETURL%<br>

			<br>
			Thank You,
			<br>
			The team at %BLOGNAME%','tpsupport'),

			),






			),

			'notification_settings' => array(
				array(
					'name' => 'tps_admin_email_notification',
					'label' => __( 'Want admin to receive new user notification email?', 'tpsupport' ),
					'desc' => __( 'Use this feature, if you want to make sure admin receives email on new user registration.', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),	
				array(
					'name' => 'notify_admin',
					'label' => __( 'Notify site admins (on new ticket creation)', 'tpsupport' ),
					'desc' => __( 'Yes', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				/*array(
					'name' => 'admin_notification_text',
					'label' => __( 'Admin Notification', 'tpsupport' ),
					'desc' => __( 'Message that admin will get on new file upload', 'tpsupport' ),
					'type' => 'textarea',
					'default' => 'Someone uploaded a new UGC file, please moderate at: ' . admin_url( 'upload.php?page=manage_front_form' ),
					'sanitize_callback' => 'wp_kses_post'
				),*/
				array(
					'name' => 'notification_email',
					'label' => __( 'Notification email of site admin', 'tpsupport' ),
					'desc' => __( 'Leave blank to use site admin email: ', 'tpsupport' ). " <i>".get_option( 'admin_email' )."</i>",
					'type' => 'text',
					'default' => '',
					'sanitize_callback' => 'sanitize_email',
				),	
				array(
					'name' => 'replyto_email',
					'label' => __( 'Reply To email address for Ticket Comments ', 'tpsupport' ),
					'desc' => __( 'Ticket owner will reply ticket comments to this email address. Leave blank to use above Notification email', 'tpsupport' ),
					'type' => 'text',
					'default' => '',
					'sanitize_callback' => 'sanitize_email',
				),				
				array(
					'name' => 'notify_ticket_creator',
					'label' => __( 'Notify Ticket Creator <br>(on ticket creation and new reply)', 'tpsupport' ),
					'desc' => __( 'Yes', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),			
			),
			'pages_settings' => array(
				array(
					'name' => 'tps_page_user_login',
					'label' => __( 'User Login Page', 'tpsupport' ),
					'desc' => __('Specify User login page. (Specified page should have proper shortcode added.)','tpsupport'),
					'type' => 'select',
					'default' => '',
					'options' => $pages_sel,
				),
				array(
					'name' => 'tps_page_user_register',
					'label' => __( 'User Registration Page', 'tpsupport' ),
					'desc' => __('Specify User registration page. (Specified page should have proper shortcode added.)','tpsupport'),
					'type' => 'select',
					'default' => '',
					'options' => $pages_sel,
				),
				array(
					'name' => 'tps_page_user_profile',
					'label' => __( 'User Profile Page', 'tpsupport' ),
					'desc' => __('Specify User profile page. (Specified page should have proper shortcode added.)','tpsupport'),
					'type' => 'select',
					'default' => '',
					'options' => $pages_sel,
				),
				array(
					'name' => 'tps_page_new_ticket',
					'label' => __( 'Generate New Ticket Page', 'tpsupport'),
					'desc' => __('Specify page for generating new support ticket. (Specified page should have proper shortcode added.)','tpsupport'),
					'type' => 'select',
					'default' => '',
					'options' => $pages_sel,
				),
				array(
					'name' => 'tps_page_ticket_view',
					'label' => __( 'Ticket Detail Page', 'tpsupport'),
					'desc' => __('Specify page to show full detail of support ticket. (Specified page should have proper shortcode added.)','tpsupport'),
					'type' => 'select',
					'default' => '',
					'options' => $pages_sel,
				),
				array(
					'name' => 'tps_page_receive_email_comments',
					'label' => __( 'Receive Email Replies', 'tpsupport' ),
					'desc' => __('Specify the cron job page, which reads the email comments posted by user. (This page should be called using cron job at regular intervals from your web server.) (Specified page should have proper shortcode added.)','tpsupport'),
					'type' => 'select',
					'default' => '',
					'options' => $pages_sel,
				),
				array(
					'name' => 'tps_page_auto_close',
					'label' => __( 'Auto Close Solved Tickets Page', 'tpsupport'),
					'desc' => __('Specify page for auto changing status of solved tickets to closed. This page can be run using Cron job at regular intervals. (Specified page should have proper shortcode added.)','tpsupport'),
					'type' => 'select',
					'default' => '',
					'options' => $pages_sel,
				),
				array(
					'name' => 'tps_page_faq_module',
					'label' => __( 'FAQ Listing Page', 'tpsupport' ),
					'desc' => __('Specify FAQ page on your site. (Specified page should have proper shortcode added.)','tpsupport'),
					'type' => 'select',
					'default' => '',
					'options' => $pages_sel,
				),
				array(
					'name' => 'tps_page_faq_detail',
					'label' => __( 'FAQ Detail Page', 'tpsupport' ),
					'desc' => __('Specify FAQ detail page or FAQ single view page. (Specified page should have proper shortcode added.)','tpsupport'),
					'type' => 'select',
					'default' => '',
					'options' => $pages_sel,
				),
				array(
					'name' => 'tps_login_redirect',
					'label' => __( 'Global Login Redirect', 'tpsupport' ),
					'desc' => __('Redirect user to a specific page after login','tpsupport'),
					'type' => 'select',
					'default' => 'same',
					'options' => $pages_same,
				),
				array(
					'name' => 'tps_logout_redirect',
					'label' => __( 'Global Logout Redirect', 'tpsupport' ),
					'desc' => __('Redirect user to a specific page after logout','tpsupport'),
					'type' => 'select',
					'default' => 'same',
					'options' => $pages_same,
				),
			),
			'userfeedback_settings' => array(

				array(
					'name' => 'enable_user_rating',
					'label' => __( 'Enable User feedback / Rating after Ticket is Solved', 'tpsupport' ),
					'desc' => __( 'This feature will allow users to rate and provide feedback for the support received', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => 'on',
				),
				array(
					'name' => 'feedback_email_after_hours',
					'label' => __( 'Enter Time to send Email (asking for feedback & rating) after ticket is marked as solved (Time unit is seconds)', 'tpsupport' ),
					'desc' => __( 'An email is sent to ticket owner after this time, once the ticket is marked as solved. This script is run by setting a cron job on site hosting server. Time is in seconds. Default is 10800 seconds (3 hours)', 'tpsupport' ),
					'type' => 'text',
					'default' => '10800',
				),

				array(
					'name' => 'feedback_email_auto_close_time',
					'label' => __( 'Enter Days Time to Auto Close Ticket, in case if user feedback in enabled and if no rating is received from user (Time unit is days)', 'tpsupport' ),
					'desc' => __( 'In case if no rating is received from user, Solved ticket will be marked as Closed automatically after these number of days. Time is in days. Default is 3 days. Note: Time is calculated after ticket is marked as solved. Please make sure this time is not less than the above send email time.', 'tpsupport' ),
					'type' => 'text',
					'default' => '3',
				),
							
			),
			'assign_agent_settings' => array(
				
				array(
					'name' => 'assign_ticket_agent',
					'label' => __( 'Auto Assign Ticket Agent <br>(Automatically on Ticket Creation)', 'tpsupport' ),
					'desc' => __( 'Yes', 'tpsupport' ),
					'type' => 'checkbox',
					'default' => '',
				),

				array(
					'name' => 'assign_ticket_method',
					'label' => __( 'Assign Tickets by Method', 'tpsupport' ),
					'desc' => __( 'Please pick a method to auto assign ticket', 'tpsupport' ),
					'type' => 'radio',
					'options' => array("assign_to_anyone" => __( 'Method 1: Assign to any one agent or group', 'tpsupport' ), "assign_to_one_from_multiple" => __( 'Method 2: Assign to any one from multiple selected agents', 'tpsupport' )),
					'default' => 'assign_to_anyone',
				),
				array(
					'name' => 'method1_message',
					'label' => __( 'Method 1: Assign to any one agent or group', 'tpsupport' ),
					'desc' => '',
					'type' => 'displaymessage',
					'default' => '',
				),
				array(
					'name' => 'assign_to_anyone',
					'label' => __( 'Select Anyone', 'tpsupport' ),
					'desc' => 'Ctrl click to select multiple agents',
					'type' => 'selectoptgroup',
					'default' => 'all',
					'options' => array('0' => __( 'Select Anyone', 'tpsupport' ),
						array(
							'label' => __( 'Select Agents', 'tpsupport' ),
							'arr' => tps_get_all_entities_arr('agents','')
						),
						array(
							'label' => 'Select Agent Group', 
							'arr' => tps_get_all_entities_arr('groups','')
						),
						array(
							'label' => 'Select Agent Group Admins', 
							'arr' => tps_get_all_entities_arr('groupsadmin','')
						),
						array(
							'label' => 'Select Agent Admin', 
							'arr' => tps_get_all_entities_arr('agentadmin','')
						),
					),

				),

				array(
					'name' => 'method2_message',
					'label' => __( 'Method 2: Assign to any one from multiple selected agents', 'tpsupport' ),
					'desc' => '',
					'type' => 'displaymessage',
					'default' => '',
				),
				array(
					'name' => 'assign_ticket_order',
					'label' => __( 'Assign Ticket Order', 'tpsupport' ),
					'desc' => __( 'Select method to automatically assign tickets to agents. Only one of selected agent will be assigned ticket', 'tpsupport' ),
					'type' => 'radio',
					'options' => array("loop" => "In loop order", "lowest" => "Agent with Lowest number Open tickets"),
					'default' => '',
				),
				array(
					'name' => 'assign_to_one_from_multiple',
					'label' => __( 'Select Entity to assign Ticket', 'tpsupport' ),
					'desc' => __( 'Select agents or group to assign tickets to (in order of above selected assign ticket method). Only one of selected agent will be assigned ticket', 'tpsupport' ),
					'type' => 'radio',
					'options' => array(
						"assign_to_agents" => "All/Selected Agents below", 
						"assign_to_agentadmins" => "All/Selected Agent Admins below", 
						"assign_to_groups" => "All/Selected Agent Groups below",
						"assign_to_group_admins" => "All/Selected Agent Groups&apos; Admin below",
						"assign_to_group_agents" => "All agents from selected Agent Group below",
						"assign_by_topic" => "To a Agent Group based on Selected Ticket Topic",
					),
					'default' => 'assign_to_agents',
				),
				array(
					'name' => 'assign_to_agents',
					'label' => __( 'Select Agents', 'tpsupport' ),
					'desc' => 'Ctrl click to select multiple agents',
					'type' => 'multiselect',
					'default' => 'all',
					'options' => tps_get_all_entities_arr('agents','all'),
				),
				array(
					'name' => 'assign_to_agentadmins',
					'label' => __( 'Select Agent Admins', 'tpsupport' ),
					'desc' => 'Ctrl click to select multiple agent admins',
					'type' => 'multiselect',
					'default' => 'all',
					'options' => tps_get_all_entities_arr('agentadmin','all'),
				),
				array(
					'name' => 'assign_to_groups',
					'label' => __( 'Select Agent Groups', 'tpsupport' ),
					'desc' => 'Ctrl click to select multiple agent groups',
					'type' => 'multiselect',
					'default' => 'all',
					'options' => tps_get_all_entities_arr('groups','all'),
				),
				array(
					'name' => 'assign_to_group_admins',
					'label' => __( 'Select Agent Groups&apos; Admin', 'tpsupport' ),
					'desc' => 'Ctrl click to select multiple Agent Groups&apos; Admin',
					'type' => 'multiselect',
					'default' => 'all',
					'options' => tps_get_all_entities_arr('groupsadmin','all'),
				),
				array(
					'name' => 'assign_to_group_agents',
					'label' => __( 'Select Agent Group', 'tpsupport' ),
					'desc' => 'All agents in this group are selected. Only one of these selected agents will be assigned ticket',
					'type' => 'select',
					'default' => '',
					'options' => tps_get_all_entities_arr('groups','',true),
				),

				array(
					'name' => 'assign_by_topic',
					'label' => __( 'Map Topic with Agent Group', 'tpsupport' ),
					'desc' => __('Ticket will be auto assigned to Mapped Group based on ticket topic', 'tpsupport' ),
					'type' => 'selectmap',
					'default' => 'all',
					'options' => array(
							'topics' => get_terms('topic', array('hide_empty' => false)),
							'groups' => tps_get_all_entities_arr('groups','')
						),
				),
			),

			/*'imap_settings' => array(
				
			),*/
			'messages_settings' => array(
				
				array(
					'name' => 'tps_response_sent',
					'label' => __( 'Ticket Submitted successfully message', 'tpsupport' ),
					'desc' => __( 'This message will be shown to user when ticket is submitted successfully', 'tpsupport' ),
					'type' => 'text',
					'default' => __('Your ticket was successfully submitted!','tpsupport'),
				),
				array(
					'name' => 'tps_response_sent_comment',
					'label' => __( 'Ticket Comment Submitted successfully message', 'tpsupport' ),
					'desc' => __( 'This message will be shown to user when comment on ticket is submitted successfully', 'tpsupport' ),
					'type' => 'text',
					'default' => __('Your ticket comment was successfully submitted!','tpsupport'),
				),
				array(
					'name' => 'tps_response_sent_feedback',
					'label' => __( 'Ticket Feedback Submitted successfully message', 'tpsupport' ),
					'desc' => __( 'This message will be shown to user when feedback on ticket is submitted successfully', 'tpsupport' ),
					'type' => 'text',
					'default' => __('Your ticket feedback was successfully submitted!','tpsupport'),
				),
				array(
					'name' => 'tps_response_error',
					'label' => __( 'Ticket Not Submitted message', 'tpsupport' ),
					'desc' => __( 'This message will be shown to user when some error is generated and ticket is not submitted successfully', 'tpsupport' ),
					'type' => 'text',
					'default' => __('There was an error with your submission. Please try again or contact us','tpsupport'),
				),
				array(
					'name' => 'tps_response_spam',
					'label' => __( 'Spam Message and Ticket Not submitted', 'tpsupport' ),
					'desc' => __( 'This message will be shown to user when submitted data fails spam check and ticket is not generated', 'tpsupport' ),
					'type' => 'text',
					'default' => __('Your submission failed spam checks','tpsupport'),
				),
				array(
					'name' => 'tps_email_error_message',
					'label' => __( 'Confirmation email not sent', 'tpsupport' ),
					'desc' => __( 'This message will be shown if confirmation email is not sent to the user', 'tpsupport' ),
					'type' => 'text',
					'default' => __('Could not able to send the email notification','tpsupport'),
				),
				array(
					'name' => 'tps_account_activated_message',
					'label' => __( 'Account activated', 'tpsupport' ),
					'desc' => __( 'This message will be shown only once when user activates the account from email.', 'tpsupport' ),
					'default' => __('Your account has been activated. You can login now.','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_account_notactivated_message',
					'label' => __( 'Account Not activated', 'tpsupport' ),
					'desc' => __( 'This message will be shown only when user tries to login without activating the account', 'tpsupport' ),
					'default' => __('Your account has not been activated yet, please verify your email first','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_login_success_message',
					'label' => __( 'Login Success', 'tpsupport' ),
					'desc' => __( 'This message will be shown on login success.', 'tpsupport' ),
					'default' => __('You are successfully logged in.','tpsupport'),
					'type' => 'text',
				),

				array(
					'name' => 'tps_account_username_notexist',
					'label' => __( 'Username does not exist', 'tpsupport' ),
					'desc' => __( 'This message will be shown only when user tries to login with username that does not exist', 'tpsupport' ),
					'default' => __('The username you have entered does not exist.','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_login_error_message',
					'label' => __( 'Login Error', 'tpsupport' ),
					'desc' => __( 'This message will be shown on login error.', 'tpsupport' ),
					'default' => __('Username or password is incorrect.','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_password_reset_link_sent_message',
					'label' => __( 'Password Reset link sent', 'tpsupport' ),
					'desc' => __( 'This message will be shown on reset password form when reset link is sent to the user', 'tpsupport' ),
					'default' => __('Password reset link sent','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_password_reset_link_notsent_message',
					'label' => __( 'Password Reset link not sent', 'tpsupport' ),
					'desc' => __( 'This message will be shown on reset password form when reset link is not sent to the user.', 'tpsupport' ),
					'default' => __('A link to reset your password has been sent to you.','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_password_reset_invalid_email_message',
					'label' => __( 'Invalid Email on reset password form', 'tpsupport' ),
					'desc' => __( 'This message will be shown on reset password form when invalid email is entered.', 'tpsupport' ),
					'default' => __('We cannot identify any user with this email.','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_password_reset_success_message',
					'label' => __( 'Password changes success message', 'tpsupport' ),
					'desc' => __( 'This message will be shown when password has been changed successfully.', 'tpsupport' ),
					'default' => __('Your password has been changed successfully.','tpsupport'),
					'type' => 'text',
				),

				array(
					'name' => 'tps_invalid_password_reset_token_message',
					'label' => __( 'Invalid password reset token', 'tpsupport' ),
					'desc' => __( 'This message will be shown when the token in invalid.', 'tpsupport' ),
					'default' => __('This token appears to be invalid.','tpsupport'),
					'type' => 'text',
				),


			),
			'form_settings' => array(
				
				/*array(
					'name' => 'tps_signup_heading',
					'label' => __( 'Register form heading', 'tpsupport' ),
					'desc' => __( 'Enter here the heading of the Register from', 'tpsupport' ),
					'default' => __('Register','tpsupport'),
					'type' => 'text',
				),*/
				/*array(
					'name' => 'tps_signup_button_text',
					'label' => __( 'Register button text', 'tpsupport' ),
					'desc' => __( 'Enter here the text of the Register button', 'tpsupport' ),
					'default' => __('Register','tpsupport'),
					'type' => 'text',
				),*/
				/*array(
					'name' => 'tps_signin_heading',
					'label' => __( 'Login form heading', 'tpsupport' ),
					'desc' => __( 'Enter here the heading of the Login from', 'tpsupport' ),
					'default' => __('Login','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_signin_button_text',
					'label' => __( 'Login button text', 'tpsupport' ),
					'desc' => __( 'Enter here the text of the Login button', 'tpsupport' ),
					'default' => __('Login','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_resetpassword_heading',
					'label' => __( 'Reset Password form heading', 'tpsupport' ),
					'desc' => __( 'Enter here the heading of the Reset Password from', 'tpsupport' ),
					'default' => __('Reset Password','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_forgot_password_button_text',
					'label' => __( 'Forgot Password link text on login form', 'tpsupport' ),
					'desc' => __( 'Enter here the text of the Forgot Password button', 'tpsupport' ),
					'default' => __('Forgot Password','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_resetpassword_button_text',
					'label' => __( 'Reset Password button text on Reset Password form', 'tpsupport' ),
					'desc' => __( 'Enter here the text of the Reset Password button', 'tpsupport' ),
					'default' => __('Reset Password','tpsupport'),
					'type' => 'text',
				),
				array(
					'name' => 'tps_returntologin_button_text',
					'label' => __( 'Return to Login link text on Reset Password form', 'tpsupport' ),
					'desc' => __( 'Enter here the text of the Return to login link', 'tpsupport' ),
					'default' => __('Return to Login','tpsupport'),
					'type' => 'text',
				),*/

				/*
				array(
					'name' => 'id',
					'label' => __( 'label', 'tpsupport' ),
					'desc' => __( 'desc', 'tpsupport' ),
					'default' => 'default',
					'type' => 'text',
				),*/


			),

		);

		return $settings_fields;
	}

	/**
	 * Render the UI
	 */
	function tps_plugin_page() {

		//$current_views = $this->views[current_filter()];
		//$this->settings_api->test_func("world");
		//echo "<pre>"; print_r($this->settings_api); echo "</pre>";
		echo '<div class="wrap">';
		$this->settings_api->tps_show_navigation();
		$this->settings_api->tps_show_forms();
		echo '</div>';
	}

	function tps_plugin_page_email(){

        $url = plugins_url('/', __FILE__).'../../../../css/style-admin.css';
        wp_deregister_style('tpsadmin');
        wp_register_style('tpsadmin', $url);
        wp_enqueue_style('tpsadmin');


		echo '<div class="wrap">';
		$this->settings_api->tps_show_navigation();
		//echo "hi";
		//$this->tps_submenu_callback();
		//$this->settings_api->tps_show_forms();



			if (isset($_POST["tps-settings-submit"]) && $_POST["tps-settings-submit"] == 'Y') {
			    if (!isset($_POST['_wpnonce']) || !wp_verify_nonce($_POST['_wpnonce'], 'save_settings')) {
			        die('Save settings check failed.');
			    }
	            //check_admin_referer("tps-settings-page");
	            $this->tps_save_email_settings();
	            }
	    
		$settings_fields = $this->tps_get_settings_fields();
		$email_settings_fields = $settings_fields['email_settings'];

        global $pagenow;

        ?>
		<div class='metabox-holder'>		
        <div class="postbox">
        	<div class='email_settings_wrapper'>
            <h2><?php echo __('Email & IMAP Settings','tpsupport'); ?></h2>

            <?php if (isset($_GET['updated']) && 'true' == esc_attr($_GET['updated'])) { 
                echo '<div class="updated"><p>Settings updated.</p></div>';
            }

            ?>

            <div id="poststuff">
                <form method="post" action="<?php admin_url('admin.php?page=tps-settings'); ?>">
                    <?php
                    wp_nonce_field("tps-settings-page");

 					$tab = 'email_settings_new';
 					$tps_settings = get_option('tps_' . $tab . '_settings');

			        $get_email_settings = get_option('email_settings');
			       // echo "<pre>"; print_r($get_email_settings); echo "</pre>";

                    ?>
                        <table class="form-table">

					<?php 
					/*if ( current_user_can('unfiltered_html') ) {
						echo "hhihi";
					} else {
						echo "nono";
					}*/
					foreach ($email_settings_fields as $args) { 
					?>	

					<tr valign="top">
					    <th>
					        <label><?php echo __($args['label'], "tpsupport"); ?></label>
					    </th>
					    <td>

						<?php $value = "";
						if(isset($get_email_settings[$args['name']])){
							$value = $get_email_settings[$args['name']];
					    	$value = str_replace("!@#$#%new#$#@!","\n", $value);
					    	$value = str_replace("!@#$#%tab#$#@!","\t", $value);
					    	$value = str_replace("!@#$#%lt#$#@!","<", $value);
					    	$value = str_replace("!@#$#%gt#$#@!",">", $value);
						}


							//echo "<pre>"; print_r($args); echo "</pre>";	
							//echo $value;

					        // esc_attr( $this->get_option( $args['id'], $args['section'], $args['std'] ) );

						if($args['type'] == 'checkbox'){

					        $html = "";
					        $html .= sprintf( '<input type="checkbox" class="checkbox" id="%1$s" name="%1$s" value="on" %3$s />', $args['name'], $value, checked( $value, 'on', false ) );
					        $html .= sprintf( '<label for="%1$s"> %2$s</label>', $args['name'], $args['desc'] );
					        echo $html;

						}
						if($args['type'] == 'textarea'){
							$size = "large";
					        $html = '<textarea rows="5" cols="55" class="'.$size.'-text" id="'.$args['name'].'" name="'.$args['name'].'">'.$value.'</textarea>';

					        $html .= sprintf( '<br><span class="description"> %s</span>', $args['desc'] );

					        echo $html;
								
						}
						if($args['type'] == 'text'){
							$size = "regular";
					        $html = sprintf( '<input type="text" class="%1$s-text" id="%2$s" name="%2$s" value="%3$s"/>', $size, $args['name'], $value );
					        $html .= sprintf( '<span class="description"> %s</span>', $args['desc'] );
					  		echo $html;
						}
						//echo $value;
						if($args['type'] == 'password'){
							$value = "";
							$size = "regular";
					        $html = sprintf( '<input type="password" class="%1$s-text" id="%2$s" name="%2$s" value="%3$s"/>', $size, $args['name'], $value );
					        $html .= sprintf( '<span class="description"> %s</span>', $args['desc'] );
					  		echo $html;
						} ?>
					</td>
					</tr>

						<?php
					}
					?>



                        </table>
					
					<?php

					wp_nonce_field('save_settings');
                    ?>
                        
                    <p class="submit" style="clear: both;">
                        <input type="submit" name="Submit"  class="button-primary" value="Update Settings" />
                        <input type="hidden" name="tps-settings-submit" value="Y" />
                    </p>
                </form>
				</div>
            </div>
			</div>
        </div>
        <?php
	}

function tps_save_email_settings()
    {
    	//print_r($_POST);
    	//die;
        global $pagenow;

       // if ($pagenow == 'admin.php' && $_GET['page'] == 'tps-settings') {
           /* if (isset($_GET['tab'])) {
                $tab = $_GET['tab'];
            } else {
                $tab = 'redirect';
            }*/
            //$tab = 'email_settings_new';
/*
                $tps_email_settings_new = array(
                    'tps_admin_email_notification11' => 1,
                    'tps_notification_message' => 'hello',
                    'tps_notification_message2' => 'hello2',
                );

            add_option('tps_' . $tab . '_settings',$tps_email_settings_new);
*/

			        $get_email_settings = get_option('email_settings');
			        $update_email_settings = $get_email_settings;
            
                    //$tps_settings = get_option('tps_' . $tab . '_settings');
                    foreach ($get_email_settings as $id => $value) {

                    	if($id == "tps_imap_password"){
                    		$passstr = "";

	                    	$str = $_POST[$id];
	                    	if(trim($str) != ""){
	                    		$passstr = tps_encstring($str);
	                    		// change password
	                    	} else {
	                    		// do not change
								$passstr = $value;	                    		
	                    	}
	                    	$update_email_settings[$id] = $passstr;
                    	} else {
	                    	$str = $_POST[$id];
	                    	$str = str_replace("\n", "!@#$#%new#$#@!", $str);
	                    	$str = str_replace("\t", "!@#$#%tab#$#@!", $str);
	                    	$str = str_replace("<", "!@#$#%lt#$#@!", $str);
	                    	$str = str_replace(">", "!@#$#%gt#$#@!", $str);
	                        $update_email_settings[$id] = $str;
                    	}

                    }

                    //echo "<pre>"; print_r($get_email_settings); echo "</pre><hr><hr>";
                    //echo "<pre>"; print_r($update_email_settings); echo "</pre><hr><hr>";
                    //die;
                    update_option('email_settings', $update_email_settings);
			        $get_email_settings = get_option('email_settings');
                    //echo "<pre>"; print_r($get_email_settings); echo "</pre><hr><hr>";
       // }
    }


function tps_plugin_admin_init() {
     //All callbacks must be valid names of functions, even if provided functions are blank
    /* register_setting( 'option_group', 'option_name', 'sanitize_callback' );
     add_settings_section( 'section_id', 'section_title', 'tps_submenu_callback', 'tps_settings_email' );
     add_settings_field( 'field_id', 'field_title', 'tps_field_callback', 'section_page_type', 'section_id' );*/
}

/*function tps_add_menus() {
     add_menu_page( 'menu_page_title', 'menu_title', 'menu_capability', 'menu_slug', 'menu_callback');
     add_submenu_page( 'menu_slug', 'submenu_page_title', 'submenu_title', 'submenu_capability', 'submenu_slug', 'tps_submenu_callback' );
}*/
//add_action( 'admin_menu', 'tps_add_menus' );
/*
function tps_submenu_callback() {
     ?>
     <div class='wrap'>
          <h2>Settings</h2>
          <form method='post' action='options.php'>
          <?php 
               // 'option_group' must match 'option_group' from register_setting call /
               settings_fields( 'option_group' );
               do_settings_sections( 'option_group' );
          ?>
               <p class='submit'>
                    <input name='submit' type='submit' id='submit' class='button-primary' value='<?php _e("Save Changes1") ?>' />
               </p>
          </form>
     </div>
     <?php
}


function tps_field_callback(){
	echo "hello";
}*/




/*function sandbox_initialize_theme_options() {
 
    // First, we register a section. This is necessary since all future options must belong to one.
    add_settings_section(
        'general_settings_section',         // ID used to identify this section and with which to register options
        'Sandbox Options',                  // Title to be displayed on the administration page
        'sandbox_general_options_callback', // Callback used to render the description of the section
        'tps_settings_email'                           // Page on which to add this section of options
    );
} // end sandbox_initialize_theme_options
 
function sandbox_general_options_callback() {
    echo '<p>Select which areas of content you wish to display.</p>';
} //
*/






	function tps_enqueue_settings_script(){

	    wp_enqueue_script('custom-js', plugin_dir_url( __FILE__ ).'../../../../js/custom-js.js');

	}

	function tps_get_all_pages(){
		return array();
	}






}

// Instantiate
$front_form_settings = new Front_Form_Settings;