<?php

add_filter( 'tps_should_process_content_upload', 'tps_recaptcha_check_submission', 10, 2 );
add_action( 'wp_head', 'tps_add_recaptcha_js' );

function tps_add_recaptcha_js() {
	global $front_form;
	?>
	<script src='<?php echo esc_url( add_query_arg( array( 'hl' => $front_form->lang_short ), 'https://www.google.com/recaptcha/api.js' ) ) ?>' async defer></script>
	<?php
}
function tps_recaptcha_check_submission( $should_process, $layout ) {

    $Front_Form = new Front_Form();
    $settings = $Front_Form->settings; 
	$recaptcha_secret_key = $settings['recaptcha_secret_key'];


	// Recaptcha is enabled but payload is missing g-recaptcha-response field
	// or it's empty
	if ( !isset( $_POST['g-recaptcha-response'] ) || ! $_POST['g-recaptcha-response'] )
		return false;

	$req = wp_remote_post( 'https://www.google.com/recaptcha/api/siteverify', array(
		'body' => array(
			'secret' => $recaptcha_secret_key,
			'response' => sanitize_text_field( $_POST['g-recaptcha-response'] ),
			'remoteip' => $_SERVER['REMOTE_ADDR']
		),
		'timeout' => 3,
	) );

	// Request failed, fail the check
	// Because we have no means to verify if it's a valid submission
	if ( is_wp_error( $req ) )
		return false;

	$res = json_decode( wp_remote_retrieve_body( $req ) );

	return $res->success;
}

function tps_recaptcha_additional_html() {
	echo tps_get_recaptcha_markup();
}