<?php

function tps_get_all_pages(){

	$arr = array();
	
	$pageids = get_all_page_ids();
	foreach ($pageids as $id) {
		$arr[$id] = get_the_title($id);
	}

	return $arr;
}

function tps_add_pre_options($arr,$default = '',$samepage = ''){
	
	$pre_add = array();
	if($default == 'select'){
		$pre_add['select'] = __('Select','tpsupport');
	}
	if($samepage == true){
		$pre_add['same'] = __('Same Page','tpsupport');
	}

	$pre_add['home'] = __('Home Page (Front Page)','tpsupport');

	//print_r($pre_add); print_r($arr); echo "<br>";
	$result = array();
	$result = $pre_add+$arr;
	return $result;
}

add_action('init', 'tps_get_all_pages');

function tps_time_elapsed_string($datetime, $full = false) {
	//return $datetime;
    $now = new DateTime(current_time('mysql')); // return local date
    $ago = new DateTime($datetime);
    $diff = $now->diff($ago);

    $diff->w = floor($diff->d / 7);
    $diff->d -= $diff->w * 7;

    $string = array(
        'y' => 'year',
        'm' => 'month',
        'w' => 'week',
        'd' => 'day',
        'h' => 'hour',
        'i' => 'minute',
        's' => 'second',
    );
    foreach ($string as $k => &$v) {
        if ($diff->$k) {
            $v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
        } else {
            unset($string[$k]);
        }
    }

    if (!$full) $string = array_slice($string, 0, 1);
    return $string ? implode(', ', $string) . ' '.__('ago','tpsupport') : __('just now','tpsupport');
}

function tps_get_assigned_agent_name_for_frontend($assign,$location = ""){

	if(is_numeric($assign)){
		// get user display_name by id
		$user = get_user_by('id',$assign );
		return $user->display_name;
	} else {
		$exp = explode("-", $assign);
		if($exp[0] == "G"){
			// Group
			return get_the_title($exp[1]);
		} else if($exp[0] == "GA"){
			// group admin
			if($location == "comment_history"){
				return get_the_title($exp[1])." ".__("Admin","tpsupport");
			}
			return get_the_title($exp[1]); //." Admin";
		}

	}
	return "";
	//return $assign;

}




function tps_comment_author_details($value,$Front_Form){


					 		//print_r($value);
							$value['userId'] = htmlentities($value['userId']);
							// has user email
							if(strpos($value['userId'], "@") !== false){
						 		$c_exp = explode("|||-",$value['userId']);
							} else {
						 		$c_exp = explode("-",$value['userId']);
							}
					 		//print_r($c_exp);
					 		$val_userId = "";
					 		$val_ts = "";
					 		$e_email = $e_name = "";
					 		$getuserbyemail = "";
					 		$comment_disp_name = "";
					 		
					 		// user id present
					 		if(isset($c_exp[0]) && is_numeric($c_exp[0])){
						 		$val_userId = $c_exp[0];
					 		} 

					 		// user email present
					 		else if(isset($c_exp[0]) && !is_numeric($c_exp[0])){
						 		$val_userId = ""; //$c_exp[0];
						 		//echo $c_exp[0];
						 		//echo $c_exp[0];
								if($c_exp[0] != ""){
									$e1_exp = explode("&lt;",$c_exp[0]);
							 		$e2_exp = explode("&gt;",$e1_exp[1]);
							 		$e_name = str_replace("|||", "", $e1_exp[0]);
									$e_email = $e2_exp[0];
								}
						 		//echo "##".$e_name."##";
						 		//echo "##".$e_email."##";
								//$e_email = "leena@gm.com";								
								$getuserbyemail = filter_var( $e_email, FILTER_VALIDATE_EMAIL );
								
								//echo "%%".$getuserbyemail."%%";

					 		}
					 		if($getuserbyemail != ""){
					 			$comment_user = get_user_by("email",$getuserbyemail);
									if(isset($comment_user->ID)){
										$val_userId = $comment_user->ID;
										$comment_disp_name = $comment_user->display_name;
									} else {
										//echo "no user found";
										$comment_disp_name = $e_name." &lt;".$e_email."&gt;";
									}
					 		} else if($val_userId != "") {
								 $comment_user = get_user_by("id",$val_userId);
								 $comment_disp_name = $comment_user->display_name;
					 		}

					 		if(isset($c_exp[1]) && is_numeric($c_exp[1])){
					 			$val_ts = $c_exp[1];
					 		}

							 $avatar = "";
							 if($val_userId != "" && get_avatar($val_userId, 40)){
							 	$avatar = "<span class='pic'>".get_avatar($val_userId, 40 )."</span>";
							 }

							 $elapsed_time = "";
							 $comment_date = "";
							 $comment_elapsed_time = "";
							 if($val_ts != ""){
								 $comment_date = $Front_Form->tps_get_current_time("localYmdHisfromts",$val_ts);
								 $comment_elapsed_time = tps_time_elapsed_string($comment_date);
							 }

							 //print_r($comment_user);

							 echo "<div class='ticket-author'>
							 	".$avatar."
								<span class='det'>
									<span class='name'>".$comment_disp_name."</span>
									<span class='time' title='".$comment_date."'>".$comment_elapsed_time."</span>
								</span>
							 </div>";

	}

function tps_getInbetweenStrings($start, $end, $str){
    $matches = array();
    $regex = "/$start([a-zA-Z0-9_]*)$end/";
    preg_match_all($regex, $str, $matches);
    return $matches[1];
}

function tps_encstring($string){
	return trim(base64_encode(AUTH_KEY.$string.AUTH_KEY));
}

function tps_decstring($string){
	return trim(str_replace(AUTH_KEY, "", base64_decode($string)));
}
?>