<?php

class TPS_User_Profile {

	
	function __construct() {
		// Init
		add_action( 'init', array( $this, 'tps_user_profile_init' ) );
	}
	

	function tps_user_profile_init() {

		// Currently supported shortcodes
		add_shortcode( 'tps-user-profile', array( $this, 'tps_display_user_profile' ) );


	}

	public static function tps_get_user_type($user_det){

		$user_type = "";

		if(isset($user_det->roles) && is_array($user_det->roles)){
				if(in_array("client",$user_det->roles)){
					$user_type = "client";
				}
				if(in_array("agent",$user_det->roles)){
					$user_type = "agent";
				}
				if(in_array("agentadmin",$user_det->roles)){
					$user_type = "agentadmin";
				}
				if(in_array("administrator",$user_det->roles)){
					$user_type = "administrator";
				}
			}
			//echo $user_type;

			return $user_type;
	}

	function tps_agent_meta_query($userID){
		
			$agent_groups = $this->tps_get_agent_groups($userID);

			//echo "<pre>"; print_r($agent_groups); echo "</pre>";
			$meta_query = array();
			
			$meta_query['relation'] = 'OR';
			
			$meta_query[] = array(
				      'key'    => 'tps_assign', 
					  'value'  => $userID,
				    );

			if(sizeof($agent_groups['agent_of_groups'])){
				$meta_query[] = array(
						'key'     => 'tps_assign',
						'value'   => $agent_groups['agent_of_groups'],
						'compare' => 'IN',
					);
			}

			if(sizeof($agent_groups['admin_of_groups'])){
				$meta_query[] = array(
						'key'     => 'tps_assign',
						'value'   => $agent_groups['admin_of_groups'],
						'compare' => 'IN',
					);
			}

			$meta_query[] = array(
						'key'     => 'tps_allagents',
						'value'   => "|".$userID."|",
						'compare' => 'LIKE',
					);

			return $meta_query;
	}

	function tps_display_user_profile( $atts, $content = null ){
		

		extract( shortcode_atts( array(
					'class' => '',
				), $atts ) );
		global $paged;


		$url = plugins_url('/', __FILE__).'../css/style.min.css';
        wp_deregister_style('tps-style-front');
        wp_register_style('tps-style-front', $url);
        wp_enqueue_style('tps-style-front');

		if(!is_user_logged_in()){
			echo __("Please Sign In or Sign Up to continue", "tpsupport");
			return;
		}

		$Front_Form = new Front_Form();
		$settings = $Front_Form->settings; 

		$user_det = wp_get_current_user();
		//echo "<pre>"; print_r($user_det); echo "</pre>"; 
		$user_type = $this->tps_get_user_type($user_det);

		
		$user_email = $user_det->data->user_email;
		//echo "|".$user_det->ID."|"; echo $user_type."|".$user_email;


			// sorting start
		$by = "";
		$col = "";
		$ord = "";

		if(isset($_GET['by']) && trim($_GET['by']) != ""){
			$by = trim($_GET['by']);
		}
		if(isset($_GET['order']) && trim($_GET['order']) != ""){
			$ord = trim($_GET['order']);
		}

		$column = array();
		$column['ID'] = 'ID';
		$column['subject'] = 'title';
		$column['created'] = 'date';
		$column['activity'] = 'tps_last_activity';
		$column['assign'] = 'tps_assign';
		$column['status'] = 'tps_status';
		$column['feedback_status'] = 'tps_feedback_status';

		if(isset($column[$by])){
			$col = $column[$by];
		}
		if(in_array($col, array('ID','date','title'))){
			$meta_key = '';
			$orderby = $col;
		}
		else if(in_array($col, array('tps_last_activity','tps_assign'))){
			$meta_key = $col;
			$orderby = 'meta_value_num';
		}
		else if(in_array($col, array('tps_status','tps_feedback_status'))){
			$meta_key = $col;
			$orderby = 'meta_value';
		} else {
			$meta_key = '';
			$orderby = 'ID';
		}

		$order = 'DESC';
		if(in_array($ord, array('ASC','DESC'))){
			$order = $ord;
		}

		//echo $order;

		$linkorder = array();
		$arrow = array();
		$linkorder = array(
			"ID" => "",
			"title" => "",
			"date" => "",
			"tps_last_activity" => "",
			"tps_assign" => "",
			"tps_status" => "",
			"tps_feedback_status" => "",
		);
		$arrow = array(
			"ID" => "",
			"title" => "",
			"date" => "",
			"tps_last_activity" => "",
			"tps_assign" => "",
			"tps_status" => "",
			"tps_feedback_status" => "",
		);

		$status_desc = array(
			"new" => __("Ticket Generated by user.","tpsupport"),
			"open" => __("Waiting for reply from Agent","tpsupport"),
			"pending" => __("Waiting for reply from User","tpsupport"),
			"solved" => __("Ticket Solved","tpsupport"),
			"closed" => __("Ticket Closed","tpsupport")
		);


		$feedback_status_desc = array(
			"na" => __("Feedback Email Not sent Or Ticket Unsolved Yet","tpsupport"),
			"waiting" => __("Email Sent. Waiting for Feedback","tpsupport"),
			"good" => __("Rated Good","tpsupport"),
			"bad" => __("Rated Bad","tpsupport"),
			"nofeedback" => __("No Feedback Received","tpsupport")
		);

		$feedback_status_display = array(
			"na" => __("-","tpsupport"),
			"waiting" => __("Waiting","tpsupport"),
			"good" => __("Good","tpsupport"),
			"bad" => __("Bad","tpsupport"),
			"nofeedback" => __("No Feedback","tpsupport")
		);


		foreach ($column as $key => $value) {
			if($value == $col && $order == "ASC"){
				$linkorder[$value] = "DESC";
				$arrow[$value] = ' &#8593;';
			} else {
				$linkorder[$value] = "ASC";
				if($value == $col){
					$arrow[$value] = ' &#8595;';
				}
			}
		}


		if($user_type == "client"){

			// load all ticket ids - same email and same ticket author
			$query1 = new WP_Query(array(
				'fields' => 'ids',
				'post_type' => 'tickets', 
				'posts_per_page' => -1,
				'meta_query'     => array(
				    array(
				      'key'    => 'tps_email', 
					  'value'  => $user_email,
				    ) 
				  ),
				)
			);

			$query2 = new WP_Query(array(
				'fields' => 'ids',
				'post_type' => 'tickets', 
				'posts_per_page' => -1,
				'author' =>  $user_det->ID,
				)
			);

			// Merge all ids of query1 and query2
			$allTheIDs = array_merge($query1->posts,$query2->posts);

			if(sizeof($allTheIDs) > 0){

				$loop = new WP_Query(array(
						'post__in' => $allTheIDs,
						'post_type' => 'tickets', 
						'paged' => $paged,
						'order'     => $order,
						'meta_key' => $meta_key,
						'orderby'   => $orderby,
					)
				);

				//echo $loop->request;
			}

		} else if($user_type == "agent"){


			// find all tickets
			// assigned to this agent
			// assigned to group of this agent

			//if agent is group admin, 
			// - then show all group tickets
			// - show tickets assigned to group admin only

			$meta_query = $this->tps_agent_meta_query($user_det->ID);
				  
			//echo "<pre>"; print_r($meta_query); echo "</pre>";

			$loop = new WP_Query( array( 
				'post_type' => 'tickets', 
				'paged' => $paged,
				'meta_query' => $meta_query,
				'order'     => $order,
				'meta_key' => $meta_key,
				'orderby'   => $orderby,
				) 
			);

			//echo $loop->request;



		} else if($user_type == "agentadmin" || $user_type == "administrator" || current_user_can( 'manage_options' ) || current_user_can( 'setup_network' )){


			$loop = new WP_Query( array( 
				'post_type' => 'tickets', 
				'paged' => $paged,
				'order'     => $order,
				'meta_key' => $meta_key,
				'orderby'   => $orderby,
				 ) 
			);
		}

		if(isset($loop)){
	    if ( $loop->have_posts() ) :
			
			$profileurl = get_permalink();
		
	    	echo "<table border=0 cellspacing=0 cellpadding=0 class='ticket-list'><tr>
	    	<th class='show-mob'><a href='".$profileurl."?by=ID&order=".$linkorder['ID']."'>".__('ID','tpsupport')."</a><span class='arrow'>".$arrow['ID']."</span></th>
	    	<th class='show-mob'><a href='".$profileurl."?by=subject&order=".$linkorder['title']."'>".__('Subject','tpsupport')."</a><span class='arrow'>".$arrow['title']."</span></th>
	    	<th class='hide-mob'><a href='".$profileurl."?by=created&order=".$linkorder['date']."'>".__('Created On','tpsupport')."</a><span class='arrow'>".$arrow['date']."</span></th>
	    	<th class='hide-mob'><a href='".$profileurl."?by=activity&order=".$linkorder['tps_last_activity']."'>".__('Last Activity','tpsupport')."</a><span class='arrow'>".$arrow['tps_last_activity']."</span></th>
	    	<th class='hide-mob'><a href='".$profileurl."?by=assign&order=".$linkorder['tps_assign']."'>".__('Assigned To','tpsupport')."</a><span class='arrow'>".$arrow['tps_assign']."</span></th>
	    	<th class='show-mob'><a href='".$profileurl."?by=status&order=".$linkorder['tps_status']."'>".__('Status','tpsupport')."</a><span class='arrow'>".$arrow['tps_status']."</span></th>
	    	<th class='hide-mob'><a href='".$profileurl."?by=feedback_status&order=".$linkorder['tps_feedback_status']."'>".__('Feedback Status','tpsupport')."</a><span class='arrow'>".$arrow['tps_feedback_status']."</span></th>
	    	</tr>";

	        while ( $loop->have_posts() ) : $loop->the_post(); ?>
	            <tr class="">
	                <?php 
	                $ticket_details_pageid = $settings['tps_page_ticket_view']; //329;
				    $status = get_post_meta( get_the_ID(), 'tps_status', true );
				    $feedback_status = get_post_meta( get_the_ID(), 'tps_feedback_status', true );

				    $assign = get_post_meta( get_the_ID(), 'tps_assign', true );
				    $created_date = get_the_date('Y-m-d')." ".get_the_time('H:i:s');
				    $created_on = tps_time_elapsed_string($created_date);

				    $last_activity_ts = get_post_meta( get_the_ID(), 'tps_last_activity', true );

				    $last_activity = $created_on;

				    if($last_activity_ts != ""){
				    	//echo $last_activity_ts."<br>";
				    	//echo $created_on;
						$Front_Form = new Front_Form();
						$last_activity_date = $Front_Form->tps_get_current_time("localYmdHisfromts",$last_activity_ts);
					    $last_activity = tps_time_elapsed_string($last_activity_date); //'Y-m-d H:i:s'
				    }

				    $ticketid = get_the_id();
				   	$assigned_user = tps_get_assigned_agent_name_for_frontend($assign); 

					$assign_str = "";
	                if($user_type != "client" && $assign == "" && $status != "new"){
	                	$assign_str = "<span class='assign-danger'>NONE</span>";
	                }
	                if($assigned_user == ""){ $assigned_user = $assign_str; }

	                $feedback_desc = "";
	                $feedback_display = "";
	                if(isset($feedback_status_desc[$feedback_status])){
		                $feedback_desc = $feedback_status_desc[$feedback_status];
	                }
	                if(isset($feedback_status_display[$feedback_status])){
		                $feedback_display = $feedback_status_display[$feedback_status];
	                }

	                ?>
	                <td class="ticketid show-mob"><?php echo "".$ticketid.""; ?></td>
	                <td class="ptitle show-mob">
	                   <a href='<?php echo esc_url( add_query_arg( 'ticketid', $ticketid, get_page_link($ticket_details_pageid)) ); ?>'><?php echo get_the_title(); ?></a>
	                   <div class="tps-mobile">
	                   	
	                   	<span><span><?php echo "".__('Created On','tpsupport').":</span> ".$created_on; ?></span>
	                   	<span><span><?php echo "".__('Last Activity','tpsupport').":</span> ".$last_activity; ?></span>
	                   	<span><span><?php echo "".__('Assigned To','tpsupport').":</span> ".$assigned_user; ?></span>
	                   	<span><span><?php echo "".__('Feedback Status','tpsupport').":</span> ".$feedback_display; ?></span>

	                   </div>
	                </td>
	                <td class="hide-mob"><span title='<?php echo $created_date; ?>'><?php echo "".$created_on; ?></span></td>
	                <td class="hide-mob"><span title='<?php echo $last_activity_date; ?>'><?php echo "".$last_activity.""; ?></span></td>
	                <td class="hide-mob"><?php echo "".$assigned_user.""; ?></td>
	                <td class="show-mob"><?php echo "<span class='val status ".$status."' title='".$status_desc[$status]."'>".$status."</span>"; ?></td>
	                <td class="hide-mob"><?php echo "<span class='val feedback_status ".$feedback_status."' title='".$feedback_desc."'>".$feedback_display."</span>"; ?></td>
	            </tr>
	        <?php endwhile;

	        echo "</table>";

	        if (  $loop->max_num_pages > 1 ) : 
	        	?>
	            <div id="nav-below" class="navigation ticket-list-nav">

					<?php

						echo $paginate_links = paginate_links( array(
			                'base' => preg_replace('/\?.*/', '/', get_pagenum_link()) . '%_%',
			                'prev_text' => __( '<span class="meta-nav">&larr;</span> Previous', 'tpsupport' ),
			                'next_text' => __( 'Next <span class="meta-nav">&rarr;</span>', 'tpsupport' ),
			                'end_size'  => 1,
			                'prev_next' => true,
			                'current'   => max( 1, get_query_var('paged') ),
			                'total'     => $loop->max_num_pages
			            ));
						
					?>

	               
	            </div>
	        <?php endif;
	    endif;
	    wp_reset_postdata();
		} else {
			echo __("No Tickets Found","tpsupport");
		}

	}

	function tps_get_agent_groups($userID){

		$ret = array();
		$agent_of_groups = array();
		$admin_of_groups = array();
		$ret['agent_of_groups'] = array();
        $ret['admin_of_groups'] = array();

		$loopgroups = get_posts( array (
              'post_type' => 'agentgroups',
              'posts_per_page' => -1,
              'order' => 'ASC',
              'orderby' => 'title'
        ));
        foreach($loopgroups as $agobj){

                  $agid = $agobj->ID;
           
									$agadmins = get_post_meta($agid,"tpsag_allagents",true);
            
									
                  if(isset($agadmins['agents']) && sizeof($agadmins['agents']) > 0 && in_array($userID,$agadmins['agents'])){
                      $agent_of_groups[] = "G-".$agid;
                  }

                  if(isset($agadmins['admin']) && sizeof($agadmins['admin']) > 0 && in_array($userID,$agadmins['admin'])){
                      $admin_of_groups[] = "GA-".$agid;
                  }
        }
        $ret['agent_of_groups'] = $agent_of_groups;
        $ret['admin_of_groups'] = $admin_of_groups;

        return $ret;
	}

}


$GLOBALS['tps_user_profile'] = new TPS_User_Profile;

?>