<?php

class TPS_Receive_Mails {

	
	function __construct() {
		// Init
		add_action( 'init', array( $this, 'tps_receive_mails_init' ) );
	}
	
	function tps_receive_mails_init() {

		// Currently supported shortcodes
		add_shortcode( 'tps-receive-mails', array( $this, 'tps_display_receive_mails' ) );
	}


	function tps_display_receive_mails( $atts, $content = null ){
		
		$Front_Form = new Front_Form();
		$settings = $Front_Form->settings; 
	
		extract( shortcode_atts( array(
					'class' => '',
				), $atts ) );
		
		$hostname = $settings['tps_imap_hostname']; //'{imap.gmail.com:993/imap/ssl}inbox';
		$username = $settings['tps_imap_username']; //'rey250991@gmail.com';
		$password = tps_decstring($settings['tps_imap_password']); //'reyemails1234';


		/* try to connect */
		$inbox = imap_open($hostname,$username,$password) or die('Cannot connect to Gmail: ' . imap_last_error());

		$subject = $settings['tps_new_ticket_generated_user_notification_subject']; //'Your Ticket Id';
		$junk_after_line = $settings['tps_new_ticket_generated_user_notification_replyabove']; //"## Please type your reply above this line ##";
		$freq = $settings['tps_imap_email_frequency']; //300; // 5 mins - should be cron job frequency
		$wp_upload_dir = wp_upload_dir();


		// Initialize the WP filesystem
		if (empty($wp_filesystem)) {
		    require_once (ABSPATH . '/wp-admin/includes/file.php');
		    WP_Filesystem();
		}

		global $wp_filesystem;

	
		// show 1 day less, for emails received near 12:00am
		$yesterday = '';
		// current utc date - seconds of 1 day
		$Front_Form = new Front_Form();
		$yuts = $Front_Form->tps_get_current_time('ts') - (24 * 60 * 60);
		$yesterday = gmdate("d F Y", $yuts);
		

		/* grab emails */
		$emails = imap_search($inbox,'SUBJECT "'.$subject.'" SINCE "'.$yesterday.'"');
	

		/* if emails are returned, cycle through each... */
		if($emails) {
			
			// begin output var 
			$output = '';
			
			// put the newest emails on top 
			rsort($emails);
			$count = 0;	

			// current utc timestamp
			$cuts = $Front_Form->tps_get_current_time('ts');
			$mints = $cuts - $freq;


			$threads = array();
		
			// for every email... 
			foreach($emails as $email_number) {


				
				// get information specific to this email 
				$overview = imap_fetch_overview($inbox,$email_number,0);

				if($overview[0]->udate >= $mints && $overview[0]->udate <= $cuts){
	
					$threads[$email_number]['overview'] = $overview;

					$message = imap_fetchbody($inbox,$email_number,1);
					//$body = imap_body($inbox,$email_number);
					$structure = imap_fetchstructure($inbox,$email_number);
				
					$message = $this->tps_remove_junk($message,$junk_after_line);

					//echo "<pre>"; print_r($message); echo "</pre>";
					$threads[$email_number]['message'] = $message;

					$new_message = "";
					// iterate through lines
					foreach(preg_split("/((\r?\n)|(\r\n?))/", $message) as $line){
							//echo "|||".$line."|||<br>";
							$newline = $this->tps_process_this_line($line);

							if($newline['is_predifined'] == true){
								break;
							} else {
								$new_message .= $line."\n";
							}
					}

			
					$threads[$email_number]['message'] = $new_message;

					// attachments - start
					$attachments = array();
					$threads[$email_number]['attach_arr'] = array();
				    
				        /* if any attachments found... */
				        if(isset($structure->parts) && count($structure->parts)) 
				        {
				            for($i = 0; $i < count($structure->parts); $i++) 
				            {
				                $attachments[$i] = array(
				                    'is_attachment' => false,
				                    'filename' => '',
				                    'name' => '',
				                    'attachment' => ''
				                );

				                if($structure->parts[$i]->ifdparameters) 
				                {
				                    foreach($structure->parts[$i]->dparameters as $object) 
				                    {
				                        if(strtolower($object->attribute) == 'filename') 
				                        {
				                            $attachments[$i]['is_attachment'] = true;
				                            $attachments[$i]['filename'] = $object->value;
				                        }
				                    }
				                }

				                if($structure->parts[$i]->ifparameters) 
				                {
				                    foreach($structure->parts[$i]->parameters as $object) 
				                    {
				                        if(strtolower($object->attribute) == 'name') 
				                        {
				                            $attachments[$i]['is_attachment'] = true;
				                            $attachments[$i]['name'] = $object->value;
				                        }
				                    }
				                }

				                if($attachments[$i]['is_attachment']) 
				                {
				                    $attachments[$i]['attachment'] = imap_fetchbody($inbox, $email_number, $i+1);

				                    /* 3 = BASE64 encoding */
				                    if($structure->parts[$i]->encoding == 3) 
				                    { 
				                        $attachments[$i]['attachment'] = base64_decode($attachments[$i]['attachment']);
				                    }
				                    /* 4 = QUOTED-PRINTABLE encoding */
				                    elseif($structure->parts[$i]->encoding == 4) 
				                    { 
				                        $attachments[$i]['attachment'] = quoted_printable_decode($attachments[$i]['attachment']);
				                    }
				                }
				            }
				        }
						
				        /* iterate through each attachment and save it */
				        foreach($attachments as $attachment)
				        {
				            if($attachment['is_attachment'] == 1)
				            {
				                $filename = $attachment['name'];
				                //$threads[$email_number]['attach_arr'][] = $filename;

				                if(empty($filename)) $filename = $attachment['filename'];

				                if(empty($filename)) $filename = time() . ".dat";

								$folder = $wp_upload_dir['basedir'] . '/helpsystem';

				                if(!$wp_filesystem->is_dir($folder))
								{
									/* directory didn't exist, so let's create it */
									$wp_filesystem->mkdir($folder);
								}

				                $full_filepath = "". $folder ."/". $email_number . "-" . $filename;

				                $threads[$email_number]['attach_arr'][] = $full_filepath;
									
								$wp_filesystem->put_contents(
								  $full_filepath,
								  $attachment['attachment'],
								  FS_CHMOD_FILE // predefined mode settings for WP files
								);

				            }
				        }

				    
				} else {
					//echo "0";
					break;
				}
				
			}
			
			$readable_comments = $this->tps_process_threads($threads);
		
		}
		
		imap_close($inbox);


	} // end function


function tps_process_this_line($line){
	
	$return = array();
	$return['is_predifined'] = false;
	//echo $line."<br>";


	if(strpos($line, ", ") !== false){
		$exp = explode(",",$line);
		//echo "sizeof".sizeof($exp);
		if(sizeof($exp) == 4){
			if(strpos($exp[2], " at ") !== false){
				if(strpos($exp[2], "AM") !== false || strpos($exp[2], "PM") !== false){
					if(strpos($exp[0], "On") !== false){
						if(strpos($exp[2], ":") !== false){
							$return['is_predifined'] = true;
						}
					}
				}		
			}
		}
	}


	return $return;
}


function tps_process_threads($threads){
	
	$wp_upload_dir = wp_upload_dir();
	// Need to require these files
	if ( !function_exists('media_handle_sideload') ) {
		require_once(ABSPATH . "wp-admin" . '/includes/image.php');
		require_once(ABSPATH . "wp-admin" . '/includes/file.php');
		require_once(ABSPATH . "wp-admin" . '/includes/media.php');
	}
	

	$comments = array();
	foreach ($threads as $email_number => $arr) {

		$comments[$email_number] = array();

		$overview = $arr['overview'][0];
		$message = $arr['message'];
		$attachments = $arr['attach_arr'];

		$subject = $overview->subject;
		$subject = trim(preg_replace("/Re\:|re\:|RE\:|Fwd\:|fwd\:|FWD\:/i", '', $subject)); 
	
		//$text = "Your ticket [1077]";
		preg_match('#\[(.*?)\]#', $subject, $match);
		$ticket_id = $match[1];
	
		if($ticket_id != "" && is_numeric($ticket_id)){

			//echo $ticket_id;echo "<br>";
			$comments[$email_number]['ticket_id'] = $ticket_id;
			$comments[$email_number]['content'] = wp_filter_post_kses($message);
			$comments[$email_number]['from'] = htmlentities($overview->from);
			$comments[$email_number]['to'] = htmlentities($overview->to);
			$comments[$email_number]['date'] = $overview->date;
			$comments[$email_number]['udate'] = $overview->udate;
			$comments[$email_number]['in_reply_to'] = htmlentities($overview->in_reply_to);
			$comments[$email_number]['uid'] = $overview->uid;
			$comments[$email_number]['msgno'] = $overview->msgno;
			$comments[$email_number]['subject'] = $overview->subject;
			$comments[$email_number]['userId'] = '';

			$comments[$email_number]['attachments'] = array();

			if(sizeof($attachments) > 0){
				foreach($attachments as $name) {

					$file_basename = $ticket_id."-email-".$overview->uid."-".$email_number."-".basename($name);
					$filetype = wp_check_filetype(basename( $name ));

					$m =array( 'name' => $file_basename, 'type' => $filetype, 'tmp_name' => $name, 'error' => '0', 'size' => '' );
					$post_overrides = array(
						'post_status' => 'private',
						'post_title' => __("Attachment to Comment on ticket:","tpsupport")." "."[".$ticket_id."]",
					    'post_content' => __("Attachment of ticket comment","tpsupport"),
					    'post_excerpt' => __("Attachment of ticket comment","tpsupport"),
					);
					$upload_id = media_handle_sideload( $m, (int) $ticket_id, 'Post title', $post_overrides );
					if ( !is_wp_error( $upload_id ) ){
						$comments[$email_number]['attachments'][] = $upload_id;
					}
					//echo "upload_id:"; print_r($upload_id);
				}
			} // end if attachments


		} // end if ticket_id

	} // end foreach

	if(sizeof($comments) > 0){

		$Front_Form = new Front_Form();
		
		foreach ($comments as $key => $value) {

			// check if ticket id exists
			if ('tickets' === get_post_type($value['ticket_id'])){
				//echo "ticket exist:".$value['ticket_id']."<br>";
				
				// add ticket comment message
				$newkey = $Front_Form->tps_update_ticket_comments($value['ticket_id'],$value);
				//echo "[[".$newkey."]]";
				if($newkey != "na"){
					
						$get_status = get_post_meta($value['ticket_id'], 'tps_status', true);
	
						$details = array();
						$details = $value;
						$details['userId'] = "";
						$details['user_type'] = "client_emailreply";
						$details['user_name'] = $value['from'];
						$details['status'] = 'open';
						$details['status_type'] = "";

						if($get_status != "new" && $get_status != "closed"){
							$ticket_status = $Front_Form->tps_ticket_status($value['ticket_id'],'open',$details);
						} else if($get_status == "new"){
							$ticket_status = $Front_Form->tps_ticket_status($value['ticket_id'],'no_change_from_email',$details);
						}

					
				}

			}
		}

		echo __("Email Comments Processed Successfully", "tpsupport");

	} else {
		echo __("No new email comments found", "tpsupport");
	}

	return true; //$threads;

}

function tps_remove_junk($message,$junk_after_line){

	$return = $message;

	$return = strpos($return, $junk_after_line) ? substr($return, 0, strpos($return, $junk_after_line)) : $return;

	$return = str_replace('Content-Type: text/plain; charset="UTF-8"', '', $return);

	return $return;
}




function tps_closetags($html) {
    preg_match_all('#<([a-z]+)(?: .*)?(?<![/|/ ])>#iU', $html, $result);
    $openedtags = $result[1];
    preg_match_all('#</([a-z]+)>#iU', $html, $result);
    $closedtags = $result[1];
    $len_opened = count($openedtags);
    if (count($closedtags) == $len_opened) {
        return $html;
    }
    $openedtags = array_reverse($openedtags);
    for ($i=0; $i < $len_opened; $i++) {
        if (!in_array($openedtags[$i], $closedtags)) {
            $html .= '</'.$openedtags[$i].'>';
        } else {
            unset($closedtags[array_search($openedtags[$i], $closedtags)]);
        }
    }
    return $html;
}


}

$GLOBALS['tps_receive_mails'] = new TPS_Receive_Mails;

?>