<?php

class TPS_Ticket_View {

	
	function __construct() {
		// Init
		add_action( 'init', array( $this, 'tps_ticket_view_init' ) );
	}
	
	function tps_ticket_view_init() {

		// Currently supported shortcodes
		add_shortcode( 'tps-ticket-view', array( $this, 'tps_display_ticket_view' ) );


	}

// determine the topmost parent of a term
function tps_get_term_top_most_parent($term_id, $taxonomy){
    // start from the current term
    $parent  = get_term_by( 'id', $term_id, $taxonomy);
    $str[$term_id] = $parent->name;
  
    // climb up the hierarchy until we reach a term with parent = '0'
    while ($parent->parent != '0'){
        $str[$term_id] = $parent->name; //$term_id;
        $term_id = $parent->parent;
        $parent  = get_term_by( 'id', $term_id, $taxonomy);
    }
    $str[$parent->term_id] = $parent->name;
    
    return $str;
    return $parent;
}

// so once you have this function you can just loop over the results returned by wp_get_object_terms

function tps_get_top_parents( $taxonomy,$postid ) {
	//echo $taxonomy.$postid;
    // get terms for current post
	$r = "";
    $terms = wp_get_object_terms( $postid, $taxonomy );
    //print_r($terms);
    // set vars
    
    if(sizeof($terms) > 0){


	    $top_parent_terms = array();
	    foreach ( $terms as $term ) {
	    	
	        //get top level parent
	        $top_parent = $this->tps_get_term_top_most_parent( $term->term_id, $taxonomy );
	        //check if you have it in your array to only add it once
	       
	    }
	   // print_r($top_parent);
	    $topic_hierarchy = array_reverse($top_parent, 1); 
	   
	   
	    foreach ( $topic_hierarchy as $term_id=>$term_name ) {
	          //Add every term
	          $r .= '<a href="'. get_term_link( $term_id, $taxonomy ) . '">' . $term_name . '</a>'.
	          " > ";
	    }
	    $r = substr($r,0,-3);
	    //echo $r;
	    // return the results
	}
    return $r;

}


	function tps_display_ticket_view( $atts, $content = null ){
		

		extract( shortcode_atts( array(
					'ticketid' => '',
					'class' => '',
				), $atts ) );
		


		$url = plugins_url('/', __FILE__).'../css/style.min.css';
        wp_deregister_style('tps-style-front');
        wp_register_style('tps-style-front', $url);
        wp_enqueue_style('tps-style-front');

		$Front_Form = new Front_Form();
		$settings = $Front_Form->settings; 

		$status_desc = array(
			"new" => __("Ticket Generated by user.","tpsupport"),
			"open" => __("Waiting for reply from Agent","tpsupport"),
			"pending" => __("Waiting for reply from User","tpsupport"),
			"solved" => __("Ticket Solved","tpsupport"),
			"closed" => __("Ticket Closed","tpsupport")
		);

		if(isset($_GET['ticketid']) && $_GET['ticketid'] != "" && $_GET['ticketid'] != "0" && is_user_logged_in()){

			$ticketid = $_GET['ticketid'];
			//echo $ticketid;

			// check if user is authorized to view this ticket
			$authorized = false;
			$user_det = wp_get_current_user();
			//echo "<pre>"; print_r($user_det); echo "</pre>"; 
	
			$user_type = TPS_User_Profile::tps_get_user_type($user_det);
			$user_email = $user_det->data->user_email;
	
			//echo $user_type;


			if($user_type == "client"){

			    $post_email = get_post_meta( $ticketid, 'tps_email', true );
			    $post_author = get_post_field( 'post_author',  $ticketid);

			    //echo $post_email; //echo $user_email; //echo "|".$post_author."|";

			    if($post_author == $user_det->ID || $post_email == $user_email){
			    	$authorized = true;
			    }


			} else if($user_type == "agent"){

			    $ticket_assign = get_post_meta( $ticketid, 'tps_assign', true );
			    $ticket_allagents = get_post_meta( $ticketid, 'tps_allagents', true );
			    
				//echo "|".$ticket_assign."|";

				if(is_numeric($ticket_assign)){
					if($ticket_assign == $user_det->ID){
						$authorized = true;
					}
					// assigned to a agent
					//echo "is number";
				} else {
					// is assigned to group or group admin
					//echo "is string";
					$exp = explode("-", $ticket_assign);
					$assigntype = $exp[0];
					$agid = $exp[1];
					//echo $assigntype;
					//echo $agid;

	                $agadmins = get_post_meta($agid,"tpsag_allagents",true);
	                //print_r($agadmins); 
					// assigned to group admin
					if($assigntype == "GA"){
						if(isset($agadmins['admin']) && is_array($agadmins['admin']) && in_array($user_det->ID, $agadmins['admin'])){
							$authorized = true;
						}

					// assigned to group
					} else if($assigntype == "G"){
						if(isset($agadmins['agents']) && is_array($agadmins['agents']) && in_array($user_det->ID, $agadmins['agents'])){
							$authorized = true;
						}

					}
				} // end else

			// if user is present in past list of agents of conversations  (tps_allagents)
				if(strpos($ticket_allagents, "|".$user_det->ID."|") !== false){
						$authorized = true;
				}


			} else if($user_type == "agentadmin" || $user_type == "administrator" || current_user_can( 'manage_options' ) || current_user_can( 'setup_network' )){
				$authorized = true;
			}

			if($authorized){
				$post = get_post($ticketid); //assuming $id has been initialized
				 if($post){
					setup_postdata($post);

					$comments_enable = true;

					if(isset($_GET['rate']) && $_GET['rate'] != "" && $post->tps_status == "solved"){
						echo do_shortcode('[tps-ticket-feedback-form type="feedback" ticketid="'.$ticketid.'" rating="'.$_GET['rate'].'"]');
						echo "<div class='tps-spacer-big'></div><div class='divider'></div><div class='tps-spacer-big'></div>";
						$comments_enable = false;
					}

					if($post->tps_status == "closed"){
						$feedback_status = $post->tps_feedback_status;
						$feedback_comment = $post->tps_feedback_comment;

						if(in_array($feedback_status,array("good","bad","nofeedback"))){

							$feedback_rating = array(
								"good" => __("Good. I am Satisfied.","tpsupport"), 
								"bad" => __("Bad. I am Unsatisfied.","tpsupport"), 
								"nofeedback" => __("No Feedback Received.","tpsupport"), 
							);

							echo "<div class='ticket-feedback'>";
							echo "<p class='feedb-head'>".__("User Feedback","tpsupport")."</p>";
							tps_comment_author_details($feedback_comment[0],$Front_Form);
							echo "<p>"; 
							//echo "<span class='tit'>".__("Rated:","tpsupport")."</span> "; 
							echo "<span class='".$feedback_status."'>".$feedback_rating[$feedback_status]."</span></p>";
							
							if(trim($feedback_comment[0]['content']) != ""){

								echo "<p><span class='tit'>".__("Feedback:","tpsupport")."</span> ".$feedback_comment[0]['content']."</p>";
							}

							echo "</div>";
							//print_r($feedback_comment);

						}

					}


	                $ticket_details_pageid = $settings['tps_page_ticket_view']; //329;

	                echo "<div class='single-post'>";

	                echo "<div class='leftcol'>";
					 echo "<h3 class='ticket-title entry-title'>".
					 "<a href='".esc_url( add_query_arg( 'ticketid', $ticketid, get_page_link($ticket_details_pageid)) )."'>".$post->post_title."</a></h3>";
					 $avatar = "";
					 if(get_avatar( $post->author, 40 )){
					 	$avatar = "<span class='pic'>".get_avatar( $post->author, 40 )."</span>";
					 }

					 $elapsed_time = tps_time_elapsed_string($post->post_date);

					 echo "<div class='ticket-author'>
					 	".$avatar."
						<span class='det'>
							<span class='name'>".$post->tps_dispname."</span>
							<span class='time' title='".$post->post_date."'>".$elapsed_time."</span>
						</span>
					 </div>";

					 echo "<div class='ticket-entry-content entry-content'>"; 

					 $followup = $post->tps_followup;
		             $ticket_details_pageid = $settings['tps_page_ticket_view']; //329;

					 if($followup != "" && 'tickets' === get_post_type($followup)){
					 	echo "<div class='followup_msg'>".__("This is a follow up Ticket for previously closed Ticket ID: ","tpsupport")."<strong> <a href='".esc_url( add_query_arg( 'ticketid', $followup, get_page_link($ticket_details_pageid)) )."' target='_blank'>".$followup."</a></strong></div>";
					 }

					 echo "<article>".wpautop($post->post_content)."";
					 //print_r($post->tps_attachments); echo "<br>";
					 if(isset($post->tps_attachments) && is_array($post->tps_attachments) && sizeof($post->tps_attachments)){
					 	echo "<h3 class='ticket-inner-title'>".__('Attachments:','tpsupport')."</h3>";
					 	foreach ($post->tps_attachments as $a_id) {
					 		//echo $a_id."|";
					 		$thumb = wp_get_attachment_thumb_url($a_id);
					 		if($thumb){
					 			echo "<a href='".wp_get_attachment_url( $a_id )."' target='_blank'><span class='thumb'>"."<img src='".$thumb."'>"."</span></a>";
					 		}
					 	}
					 }

				 	 echo "</article></div>"; // end .entry-content
				 	 echo "</div>"; // .leftcol

				 	 echo "<div class='rightcol'><div class='ticket-info'>";
						 $last_activity = $Front_Form->tps_get_current_time("localYmdHisfromts",$post->tps_last_activity);
						 $assigned_user = tps_get_assigned_agent_name_for_frontend($post->tps_assign); 
						 $status_info = $status_desc[$post->tps_status];
						 //echo $status_info;
						 $ticket_solved_time = $post->tps_ticket_solved_time;
						 if(isset($ticket_solved_time) && $ticket_solved_time != "" && $post->tps_status == "solved"){
						 	//echo "hi";
						 	$status_info .= __(" On ","tpsupport").$Front_Form->tps_get_current_time("localYmdHisfromts",$ticket_solved_time);
						 }

						 echo "<p class='detrow'><span class='tit'>".__('Status:','tpsupport')."</span><span class='val status ".$post->tps_status."' title='".$status_info."'>".$post->tps_status."</span></p>";
						 echo "<p class='detrow'><span class='tit'>".__('Assigned:','tpsupport')."</span><span class='val'>".$assigned_user."</span></p>";
						 echo "<p class='detrow'><span class='tit'>".__('Created By:','tpsupport')."</span><span class='val'>".$post->tps_dispname."</span></p>";
						 echo "<p class='detrow'><span class='tit'>".__('Created On:','tpsupport')."</span><span class='val' title='".$post->post_date."'>".tps_time_elapsed_string($post->post_date)."</span></p>";
						 echo "<p class='detrow'><span class='tit'>".__('Last Activity:','tpsupport')."</span><span class='val' title='".$last_activity."'>".tps_time_elapsed_string($last_activity)."</span></p>";
						 echo "<p class='detrow'><span class='tit'>".__('Ticket ID:','tpsupport')."</span><span class='val'>".$post->ID."</span></p>";

						 echo "<p class='detrow'><span class='tit'>".__('Topic:','tpsupport')."</span><span class='val'>".$this->tps_get_top_parents( 'topic',$post->ID )."</span></p>";

						 echo "<p class='detrow'><span class='tit'>".__('Relevant URL:','tpsupport')."</span><span class='val'><a href='".$post->tps_url."' target='_blank'>".$post->tps_url."</a></span></p>";

					 echo "</div></div>"; // end .rightcol

					 echo "<div class='tps-spacer'></div>";
					 echo "<div class='ticket-comments-area'>";
				 	 
					 if(isset($post->tps_comments) && is_array($post->tps_comments)){

					 	foreach ($post->tps_comments as $key => $value) {
					 		
					 		echo "<div class='ticket-comment'>";
					 		
					 		tps_comment_author_details($value,$Front_Form);

					 		echo "<article>".wpautop($value['content'])."</article>";

					 		//print_r($value['attachments']);
							if(isset($value['attachments']) && is_array($value['attachments']) && sizeof($value['attachments'])){
								echo "<div class='comment-attachments'>";								
								foreach ($value['attachments'] as $akey => $avalue) {
									//echo "attach:".$avalue." | ";
									$athumb = wp_get_attachment_thumb_url($avalue);
							 		if($athumb){
							 			echo "<a class='thumb' href='".wp_get_attachment_url( $avalue )."' target='_blank'>"."<img src='".$athumb."'>"."</a>";
							 		}
								}
								echo "</div>";
							}

					 	echo "</div><div class='tps-spacer'></div>";

					 	}
					 
					 }
					 echo "</div>"; // .ticket-comments-area


					 if($post->tps_status == "closed"){

						$new_ticket_pageid = $settings['tps_page_new_ticket']; //329;

					 	echo __("Ticket Closed.","tpsupport");
					 	echo " <a href='".esc_url( add_query_arg( 'followup', $ticketid, get_page_link($new_ticket_pageid)) )."'>".__("Click Here to generate a follow up of this ticket.","tpsupport")."</a>";
					 } else if($comments_enable){
						echo do_shortcode('[tps-ticket-comment-form type="comment" ticketid="'.$ticketid.'" status="'.$post->tps_status.'"]');
					 }

				echo "</div>"; // .single-post end

				} else {
					echo __("No Ticket (".$ticketid.") Found.","tpsupport");
				}

				wp_reset_postdata();


			} else {
				echo __("Sorry. Not authorized to view this ticket.","tpsupport");
			}

		} else if(!is_user_logged_in()){
				echo __("Please Sign In to continue.","tpsupport");
		} else {
			echo "No ticket Found.";
		}

	}


}

$GLOBALS['tps_ticket_view'] = new TPS_Ticket_View;

?>