<?php 

add_action('init', 'tps_user_login_process', 0);

function tps_user_login_process(){

	add_action('wp_ajax_nopriv_tps_user_login', 'tps_user_login');
	add_shortcode('tps_login_form', 'tps_display_login_form');
}

function tps_display_login_form()
    {
        
        $url = plugins_url('/', __FILE__).'../css/style.min.css';
        wp_deregister_style('tps-style-front');
        wp_register_style('tps-style-front', $url);
        wp_enqueue_style('tps-style-front');


        ob_start();
        include_once 'user-account/tps-login-form.php';
        $output = ob_get_clean();
        //print $output; // debug
        return $output;

    }


function tps_user_login()
    {
        $Front_Form = new Front_Form();
        $settings = $Front_Form->settings; 
        
        $response = array();
        // checking post data
        if (isset($_POST) && $_POST) {

            $nonce = $_POST['tps_login_nonce'];
            // For security : verifying wordpress nonce
            if (!wp_verify_nonce($nonce, 'tps_login_action')) {
                _e('Failed security check !', "tpsupport");
                exit;
            }
            // preparing credentials array
            $credentials = array();
            $credentials['user_login'] = trim($_POST['tps_username']);
            $credentials['user_password'] = trim($_POST['tps_password']);

            // if email confirmation enabled
            if (isset($settings['tps_user_email_confirmation']) && $settings['tps_user_email_confirmation'] == 'on') {
                // checking if user verified his email or not
                tps_check_user_verified_email_or_not($credentials);
            }

            // auto login the user
            $user = wp_signon($credentials, false);
            // checking for authentication error
            if (is_wp_error($user)) {
                $response['error'] = __($settings['tps_login_error_message'], "tpsupport");
            } else {
                wp_set_auth_cookie($user->data->ID);
                // setting current logged in user
                wp_set_current_user($user->data->ID, $user->data->user_login);
                // Adding hook so that anyone can add action on user login
                do_action('set_current_user');
                $response['logged_in'] = true;
                $response['success'] = __($settings['tps_login_success_message'], "tpsupport");
                $response['redirection_url'] = $_POST['redirection_url'];
            }
            // sending back the response in right header
            wp_send_json($response);
        }
    }

function tps_check_user_verified_email_or_not($credentials)
    {
        //get message settings
        $Front_Form = new Front_Form();
        $settings = $Front_Form->settings; 
        
        //$settings = get_option('tps_display_settings');
        // getting user details
        $user = get_user_by('login', $credentials['user_login']);

        if (!$user->ID) {
            $response['error'] = __($settings['tps_account_username_notexist'], "tpsupport");
        } else {
            $stored_token = get_user_meta($user->ID, 'tps_email_verification_token', true);
            if (!$stored_token) {
                return true;
            } else {
                $response['error'] = __($settings['tps_account_notactivated_message'], "tpsupport");
            }
        }
        wp_send_json($response);
    }

?>