<?php

add_action('init', 'tps_user_registration_process', 0);


function tps_user_registration_process(){
	add_action('wp_ajax_nopriv_tps_user_registration', 'tps_user_registration');
	add_shortcode('tps_register_form', 'tps_display_register_form');
}

function tps_display_register_form($atts, $content = null )
{

    extract( shortcode_atts( array(
                    'role' => get_option('default_role'),
                ), $atts ) );

        $url = plugins_url('/', __FILE__).'../css/style.min.css';
        wp_deregister_style('tps-style-front');
        wp_register_style('tps-style-front', $url);
        wp_enqueue_style('tps-style-front');


    //echo $role;
    // verifing token if present
    $token_verification = tps_verify_token();
    include_once 'user-account/tps-register-form.php';
}


function tps_user_registration_mail($userdata)
{

        //print_r($userdata);
        //die;

        $Front_Form = new Front_Form();
        $settings = $Front_Form->settings; 
        //$settings = get_option('tps_email_settings');

        //prepare placeholder array

        $placeholders = array(
            '%USERNAME%' => $userdata['user_login'],
            '%BLOGNAME%' => get_option('blogname'),
            '%FIRSTNAME%' => $userdata['first_name'],
            '%LASTNAME%' => $userdata['last_name'],
            '%USEREMAIL%' => $userdata['user_email'],
            '%BLOGURL%' => "<a href='" . site_url() . "'>" . site_url() . "</a>",
            '%VERIFICATIONLINK' => ''
        );

        $to['admin'] = get_option('admin_email');
        $to['user'] = $userdata['user_email'];

        //Default subject
        $subject['user'] = __('Welcome to ','tpsupport') . get_option('blogname');

        //Subject when settngs are saved
        if (!empty($settings['tps_notification_subject'])) {
            $subject['user'] = $settings['tps_notification_subject'];
            //$subject['user'] = str_replace('%BLOGNAME%', get_option('blogname'), $subject['user']);
            $subject['user'] = tps_generic_placeholder_replacer($subject['user'], $placeholders);
        }

        //Default subject
        $subject['admin'] = __('New User registered on ','tpsupport') . get_option('blogname');

        //Subject when settngs are saved
        if (!empty($settings['tps_notification_to_admin_subject'])) {
            $subject['admin'] = $settings['tps_notification_to_admin_subject'];
            //$subject['user'] = str_replace('%BLOGNAME%', get_option('blogname'), $subject['user']);
            $subject['admin'] = tps_generic_placeholder_replacer($subject['admin'], $placeholders);
        }

       // print_r($subject);
       // die;


        // using content type html for emails
        $headers = array('Content-Type: text/html; charset=UTF-8');

        $body['user'] = "";
        //Email when settings are saved
        if (!empty($settings['tps_notification_message'])) {
            $body['user'] = $settings['tps_notification_message'];

            $body['user'] = tps_generic_placeholder_replacer($body['user'], $placeholders);
        }

        $body['admin'] = "";
        //Email when settings are saved
        if (!empty($settings['tps_notification_to_admin_message'])) {
            $body['admin'] = $settings['tps_notification_to_admin_message'];

            $body['admin'] = tps_generic_placeholder_replacer($body['admin'], $placeholders);
        }

       // $body['admin'] = $message['admin'];
        
        $admin_mail_status = "";
        //sending email notification to admin
        if ((isset($settings['tps_admin_email_notification']) && $settings['tps_admin_email_notification'] == 'on')) {
            //echo "admin mail";
            $admin_mail_status = wp_mail($to['admin'], $subject['admin'], $body['admin'], $headers);
        }

        //sending email notification to user
        $status = wp_mail($to['user'], $subject['user'], $body['user'], $headers);


     //   die;

        return $status;
    }    



function tps_user_registration()
    {


        $Front_Form = new Front_Form();
        $settings = $Front_Form->settings; 
        
        //$settings = get_option('tps_email_settings');
        
        $response = array();

        // checking post data
        if (isset($_POST) && $_POST) {
           
            $nonce = $_POST['tps_register_nonce'];
            // For security : verifying wordpress nonce
            if (!wp_verify_nonce($nonce, 'tps_register_action')) {
                _e('Failed security check !', "tpsupport");
                exit;
            }
            // preparing user array and added required filters
            $userdata = array(
                'user_login' => apply_filters('pre_user_login', trim($_POST['tps_username'])),
                'user_pass' => apply_filters('pre_user_pass', trim($_POST['tps_password'])),
                'user_email' => apply_filters('pre_user_email', trim($_POST['tps_email'])),
                'first_name' => apply_filters('pre_user_first_name', trim($_POST['tps_fname'])),
                'last_name' => apply_filters('pre_user_last_name', trim($_POST['tps_lname'])),
                'role' => trim($_POST['tps_userrole']),
                'user_registered' => date('Y-m-d H:i:s')
            );

            // creating new user
            $user_id = wp_insert_user($userdata);

            // checking for errors while user registration
            if (is_wp_error($user_id)) {
                $response['error'] = $user_id->get_error_message();
            } else {

                //adding current url in user data
                $userdata['current_url'] = $_POST['tps_current_url'];

                // Adding hook so that anyone can add action on user registration
                do_action('user_register', $user_id);

                $response['reg_status'] = true;
                //$response['success'] = __('Thanks for signing up. Please check your email for confirmation!', "tpsupport");
                //Sending user registration mails
                $email_confirmation_enabled = $settings['tps_user_email_confirmation'];
                // check if admin opt for email confirmation
                if (isset($settings['tps_user_email_confirmation']) && $settings['tps_user_email_confirmation'] == 'on') {
                    // creating and adding email verification token
                    $tps_email_verification_token = md5(wp_generate_password(26, true));
                    add_user_meta($user_id, 'tps_email_verification_token', $tps_email_verification_token);
                    $userdata['user_token'] = $tps_email_verification_token;

                    $mail_status = tps_send_email_verification_token($userdata);
                    $response['success'] = __('Thanks for signing up. Please check your email for confirmation!', "tpsupport");

                } else {
                    $mail_status = tps_user_registration_mail($userdata);
                    $response['success'] = __('You are successfully registered.', "tpsupport");
                }

                $response['redirection_url'] = $_POST['redirection_url'];
                $response['mail_status'] = $mail_status;
            }
            // sending back the response in right header
            wp_send_json($response);
        }
    }

function tps_verify_token()
    {

      
        // checking email and token
        if (isset($_GET) && (isset($_GET['tps_email_verification_token']) && $_GET['tps_email_verification_token']) && $_GET['email']) {
            $user = get_user_by('email', $_GET['email']);

            if ($user->ID)
                $stored_token = get_user_meta($user->ID, 'tps_email_verification_token', true);
            if ($stored_token == $_GET['tps_email_verification_token']) {
                // preparing user data
                $userdata = array();
                $userdata['user_login'] = $user->data->user_login;
                $userdata['user_email'] = $user->data->user_email;
                $userdata['first_name'] = get_user_meta($user->ID, 'first_name', true);
                $userdata['last_name'] = get_user_meta($user->ID, 'last_name', true);
               

                // removing token on verification
                //echo "yes token verified";
                delete_user_meta($user->ID, 'tps_email_verification_token');
                // sending registration success email
                tps_user_registration_mail($userdata);

                return true;
           }
        }

        return false;
    }




function tps_send_email_verification_token($userdata)
    {


        $Front_Form = new Front_Form();
        $settings = $Front_Form->settings; 
        
        //$settings = get_option('tps_email_settings');
        // using content type html for emails
        $headers = array('Content-Type: text/html; charset=UTF-8');
        // configuring email options
        $to = $userdata['user_email'];
        
       // $headers[] = 'From:' . get_option('blogname');
        
        
        $placeholders = array(
            '%USERNAME%' => $userdata['user_login'],
            '%BLOGNAME%' => get_option('blogname'),
            '%FIRSTNAME%' => $userdata['first_name'],
            '%LASTNAME%' => $userdata['last_name'],
            '%USEREMAIL%' => $userdata['user_email'],
            '%BLOGURL%' => "<a href='" . site_url() . "'>" . site_url() . "</a>",
            '%VERIFICATIONLINK%' => "<a target='_blank' href='" . esc_url(add_query_arg(array('email' => $userdata['user_email'], 'tps_email_verification_token' => $userdata['user_token']), $userdata['current_url'])) . "'>"
            . add_query_arg(array('email' => $userdata['user_email'], 'tps_email_verification_token' => $userdata['user_token']), $userdata['current_url']) . "</a>"
        );

        $subject = $settings['tps_new_account_verification_email_subject'];
        $subject = tps_generic_placeholder_replacer($subject, $placeholders);

        $message = $settings['tps_new_account_verification_email_message'];
        $message = tps_generic_placeholder_replacer($message, $placeholders);
        // sending confirmation email

        //return wp_mail( $to, 'WP Mail Test 11', 'Mail is working 11: ', $headers );

        return wp_mail($to, $subject, $message, $headers);
    }


?>