<?php 

add_action('init', 'tps_user_resetpassword_process', 0);

function tps_user_resetpassword_process(){

	add_action('wp_ajax_nopriv_tps_resetpassword', 'tps_resetpassword');
	add_shortcode('tps_resetpassword_form', 'tps_display_resetpassword_form');
}

function tps_display_resetpassword_form()
    {
        include_once 'user-account/tps-resetpassword-form.php';
    }


function tps_resetpassword()
    {

        $nonce = $_POST['tps_resetpassword_nonce'];
        $response = array();
        // For security : verifying wordpress nonce
        if (!wp_verify_nonce($nonce, 'tps_resetpassword_action')) {
            _e('Failed security check !', "tpsupport");
            exit;
        }

        $Front_Form = new Front_Form();
        $settings = $Front_Form->settings; 

       
        if (isset($_POST) && empty($_POST['tps_reset_password_token'])) {

            //get user details from email            
            $user = get_user_by('email', $_POST['tps_rp_email']);
            //check user exists
            if ($user->ID > 0) {

                $tps_reset_password_token = '';
                //check if token already exists
                $token_exists = get_user_meta($user->ID, 'tps_reset_password_token', true);

                if ($token_exists) {
                    //send the old token
                    $tps_reset_password_token = $token_exists;
                } else {
                    //generate new token
                    $tps_reset_password_token = md5(wp_generate_password(26, true));
                    //add new token to usermeta
                    add_user_meta($user->ID, 'tps_reset_password_token', $tps_reset_password_token);
                }


                //create info to sent in the email
                $userdata = array();
                $userdata['current_url'] = $_POST['tps_current_url'];
                $userdata['user_email'] = $user->user_email;
                $userdata['tps_reset_password_token'] = $tps_reset_password_token;
                $userdata['user_login'] = $user->user_login;

                $mail_status = tps_send_reset_password_token($userdata);

                if (true == $mail_status) {
                    $response['success'] = __($settings['tps_password_reset_link_sent_message'], "tpsupport");
                    //create response
                    wp_send_json($response);
                } else {
                    $response['error'] = __($settings['tps_password_reset_link_notsent_message'], "tpsupport");
                    wp_send_json($response);
                }
            } else {
                $response['error'] = __($settings['tps_password_reset_invalid_email_message'], "tpsupport");

                wp_send_json($response);
            }
        }
        //the user already has the token
        else if (isset($_POST) && !empty($_POST['tps_reset_password_token'])) {

            $data = array();
            $data['tps_rp_email'] = $_POST['tps_rp_email'];
            $data['tps_reset_password_token'] = $_POST['tps_reset_password_token'];
            $data['tps_newpassword'] = $_POST['tps_newpassword'];

            $status = tps_change_user_password($data);


            if ($status == true) {
                $response['success'] = __($settings['tps_password_reset_success_message'], "tpsupport");
                wp_send_json($response);
            }
            if ($status == false) {
                $response['error'] = __($settings['tps_invalid_password_reset_token_message'], "tpsupport");
                wp_send_json($response);
            }
        }
    }



function tps_send_reset_password_token($userdata)
    {

        $Front_Form = new Front_Form();
        $settings = $Front_Form->settings; 
        
        //$settings = get_option('tps_email_settings');
        // using content type html for emails
        $headers = array('Content-Type: text/html; charset=UTF-8');
        // configuring email options
        $to = $userdata['user_email'];
       // $headers[] = 'From:' . get_option('blogname');

        //placeholders

        $placeholders = array(
            '%USERNAME%' => $userdata['user_login'],
            '%BLOGNAME%' => get_option('blogname'),
            '%USEREMAIL%' => $userdata['user_email'],
            '%BLOGURL%' => "<a href='" . site_url() . "'>" . site_url() . "</a>",
            '%RECOVERYLINK%' => "<a target='_blank' href='" . esc_url(add_query_arg(array('email' => $userdata['user_email'], 'tps_reset_password_token' => $userdata['tps_reset_password_token']), $userdata['current_url'])) . "'>"
            . add_query_arg(array('email' => $userdata['user_email'], 'tps_reset_password_token' => $userdata['tps_reset_password_token']), $userdata['current_url']) . "</a>"
        );

        //Default subject
        $subject = $settings['tps_password_reset_email_subject'];
        $subject = tps_generic_placeholder_replacer($subject, $placeholders);
        $message = $settings['tps_password_reset_email_message'];
        $message = tps_generic_placeholder_replacer($message, $placeholders);

        // sending confirmation email
        return wp_mail($to, $subject, $message, $headers);
    }

function tps_change_user_password($data)
    {
        // checking email and token
        if (isset($data) && $data['tps_reset_password_token'] && $data['tps_rp_email']) {
            $user = get_user_by('email', $data['tps_rp_email']);

            if ($user->ID > 0) {
                $stored_token = get_user_meta($user->ID, 'tps_reset_password_token', true);
            }
            if ($stored_token == $data['tps_reset_password_token']) {
                // preparing user data
                $password = $data['tps_newpassword'];
                $password_reset = wp_set_password($password, $user->ID);

                // removing token on verification
                return delete_user_meta($user->ID, 'tps_reset_password_token');
            }
        }
        return false;
    }
?>